% New PRM planner

 clear all;
figure(1)
hold off
plot3(0,0,0,'o')
hold on

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(1);

% Makes the robot in final position
% finalPos = [-5 -3 -4]';
% thetaFinal = [pi/3 -pi/5 -pi/7 pi/4 pi/4 pi/6];
% [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
%    
% Makes the  robot in its initial position  
    %%%%%% Initial pose %%%%%%%
linValues = [5 5 -0.5]';     
thetaStart = [pi/3 0 -pi/6 pi/8 -pi/4 pi/6]';
[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);

% theta = [DH(5,1) DH(6,1) DH(7,1) DH(8,1) DH(9,1) DH(10,1)]';

%% Probabilisitc road map
w= [0 0.216 0.216 0.216 1.54 1.54 0.84 0.085 0.085 0.085];
weigthVec = w;
linStepLength = 1;
angularStepLength = 5*pi/180;

for i =1:10   
    i
    if i<5
        step = 0.5;
            tic;
        [Samples, Components ] = makeGaussianSamplesPot_Nearest_all_k(75, LinLimits, JALimits,1, 5/180*pi,w, step, Obstacles, oRot, oTrans);
            sampleTime(i) = toc;
        [Components Samples] = removeEmptyComponents(Components,Samples,2);
            pre_compLength(i) = length(Components);
        [pre_testConfigCovered, pre_TestQueryConnection, pre_ConnectionTime, pre_PathSearchTime, pre_testWidth ] = PRM_SamplingAnalysis_new(Components, Samples, weigthVec);

        %Storing the pre_test result

        if i==1
            pre_TotalCoverage = pre_testConfigCovered;
            pre_TestResultConnection = pre_TestQueryConnection;
        else
            pre_TotalCoverage = pre_TotalCoverage + pre_testConfigCovered;
            pre_TestResultConnection = pre_TestResultConnection + pre_TestQueryConnection;
        end

        pre_TotalConnectionTime(:,:,i) = pre_ConnectionTime;
        pre_TotalPathSearchTime(:,:,i) = pre_PathSearchTime;

        pre_coverage(i) = sum(pre_testConfigCovered)

        sumColums = sum(pre_TestQueryConnection);
        pre_sumQueriesConnection(i) = sum(sumColums)
        % Done storing the pre test results
        
        [Samples, Components, difficultWeight, lenInterMedVec] = connectionSampling_new2(Samples, Components, step,w, LinLimits, JALimits, linStepLength, angularStepLength);
            interMedUsed(i) = lenInterMedVec;
        [Components Samples] = removeEmptyComponents(Components,Samples,1);
            post_compLength(i) = length(Components);
        [post_testConfigCovered, post_TestQueryConnection, post_ConnectionTime, post_PathSearchTime, post_testWidth ] = PRM_SamplingAnalysis_new(Components, Samples, weigthVec);

        %Storing the post_test result

        if i==1
            post_TotalCoverage = post_testConfigCovered;
            post_TestResultConnection = post_TestQueryConnection;
        else
            post_TotalCoverage = post_TotalCoverage + post_testConfigCovered;
            post_TestResultConnection = post_TestResultConnection + post_TestQueryConnection;
        end

        post_TotalConnectionTime(:,:,i) = post_ConnectionTime;
        post_TotalPathSearchTime(:,:,i) = post_PathSearchTime;

        post_coverage(i) = sum(post_testConfigCovered)

        sumColums = sum(post_TestQueryConnection);
        post_sumQueriesConnection(i) = sum(sumColums)
        
    else    %Run the Gaussian test
      step = 0.5;
            tic;
        [Samples, Components ] = makeGaussianSamples_Nearest_all_k(75, LinLimits, JALimits,1, 5/180*pi,w, step, Obstacles, oRot, oTrans);
            sampleTime(i) = toc;
        [Components Samples] = removeEmptyComponents(Components,Samples,2);
            pre_compLength(i) = length(Components);
        [pre_testConfigCovered, pre_TestQueryConnection, pre_ConnectionTime, pre_PathSearchTime, pre_testWidth ] = PRM_SamplingAnalysis_new(Components, Samples, weigthVec);

        %Storing the pre_test result
        
        pre_TotalCoverage = pre_TotalCoverage + pre_testConfigCovered;
        pre_TestResultConnection = pre_TestResultConnection + pre_TestQueryConnection;        

        pre_TotalConnectionTime(:,:,i) = pre_ConnectionTime;
        pre_TotalPathSearchTime(:,:,i) = pre_PathSearchTime;

        pre_coverage(i) = sum(pre_testConfigCovered)

        sumColums = sum(pre_TestQueryConnection);
        pre_sumQueriesConnection(i) = sum(sumColums)
        % Done storing the pre test results
        
        [Samples, Components, difficultWeight, lenInterMedVec] = connectionSampling_new2(Samples, Components, step,w, LinLimits, JALimits, linStepLength, angularStepLength);
            interMedUsed(i) = lenInterMedVec;
        [Components Samples] = removeEmptyComponents(Components,Samples,1);
            post_compLength(i) = length(Components);
        [post_testConfigCovered, post_TestQueryConnection, pots_ConnectionTime, post_PathSearchTime, post_testWidth ] = PRM_SamplingAnalysis_new(Components, Samples, weigthVec);

        %Storing the post_test result

        post_TotalCoverage = post_TotalCoverage + post_testConfigCovered;
        post_TestResultConnection = post_TestResultConnection + post_TestQueryConnection;


        post_TotalConnectionTime(:,:,i) = post_ConnectionTime;
        post_TotalPathSearchTime(:,:,i) = post_PathSearchTime;

        post_coverage(i) = sum(post_testConfigCovered)

        sumColums = sum(post_TestQueryConnection);
        post_sumQueriesConnection(i) = sum(sumColums) 
    end
       
end
    
