% New PRM planner

 clear all;
figure(1)
hold off
plot3(0,0,0,'o')
hold on

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(1);

% Makes the robot in final position
% finalPos = [-5 -3 -4]';
% thetaFinal = [pi/3 -pi/5 -pi/7 pi/4 pi/4 pi/6];
% [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
%    
% Makes the  robot in its initial position  
    %%%%%% Initial pose %%%%%%%
linValues = [5 5 -0.5]';     
thetaStart = [pi/3 0 -pi/6 pi/8 -pi/4 pi/6]';
[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);

% theta = [DH(5,1) DH(6,1) DH(7,1) DH(8,1) DH(9,1) DH(10,1)]';

%% Probabilisitc road map
w= [0 0.216 0.216 0.216 1.54 1.54 0.84 0.085 0.085 0.085];
weigthVec = w;
linStepLength = 1;
angularStepLength = 5*pi/180;

for i =1:4  
%     clear aSamples bSamples cSamples dSamples eSamples fSamples gSamples hSamples
%     clear aComponents bComponents cComponents dComponents eComponents fComponents gComponents hComponents
    i
    clear aSamples bSamples cSamples dSamples
    clear aComponents bComponents cComponents dComponents
    if i<3
        step = 0.5;
            tic;
        [aSamples, aComponents ] = makeGaussianSamplesPot_Nearest_all_k(75, LinLimits, JALimits,1, 5/180*pi,w, step, Obstacles, oRot, oTrans);
            sampleTime(i) = toc;
        [bComponents bSamples] = removeEmptyComponents(aComponents,aSamples,2);
            pre_compLength(i) = length(bComponents);
        [pre_testConfigCovered, pre_TestQueryConnection, pre_ConnectionTime, pre_PathSearchTime, pre_testWidth ] = PRM_SamplingAnalysis_new(bComponents, bSamples, weigthVec);

        %Storing the pre_test result

        pre_TotalCoverage(i,:) = pre_testConfigCovered
        pre_TestResultConnection(:,:,i) = pre_TestQueryConnection;      
        pre_TotalConnectionTime(:,:,i) = pre_ConnectionTime;
        pre_TotalPathSearchTime(:,:,i) = pre_PathSearchTime;
        
        pre_coverage(i) = sum(pre_testConfigCovered)
        
        sumColums = sum(pre_TestQueryConnection);
        pre_sumQueriesConnection(i) = sum(sumColums)
        
        % Done storing the pre test results
        if pre_compLength(i)>1
            [cSamples, cComponents, difficultWeight, lenInterMedVec] = connectionSampling_new2(bSamples, bComponents, step,w, LinLimits, JALimits, linStepLength, angularStepLength);
            interMedUsed(i) = lenInterMedVec;
            [dComponents dSamples] = removeEmptyComponents(cComponents,cSamples,1);
            post_compLength(i) = length(dComponents);
            [post_testConfigCovered, post_TestQueryConnection, post_ConnectionTime, post_PathSearchTime, post_testWidth ] = PRM_SamplingAnalysis_new(dComponents, dSamples, weigthVec);

            %Storing the post_test result

            post_TotalCoverage(i,:) = post_testConfigCovered
            post_TestResultConnection(:,:,i) = post_TestQueryConnection;
            post_TotalConnectionTime(:,:,i) = post_ConnectionTime;
            post_TotalPathSearchTime(:,:,i) = post_PathSearchTime;

            post_coverage(i) = sum(post_testConfigCovered)

            sumColums = sum(post_TestQueryConnection);
            post_sumQueriesConnection(i) = sum(sumColums)
        else
            disp(' Only one connected component, no merging neccessary.')
            post_TotalCoverage(i,:) = [0 0 0 0 0 0 0 0]
            post_TestResultConnection(1:8,1:8,i) = zeros;
            post_TotalConnectionTime(1:8,1:8,i) = zeros;
            post_TotalPathSearchTime(1:8,1:8,i) = zeros;

            post_coverage(i) = 0

%             sumColums = sum(post_TestQueryConnection);
            post_sumQueriesConnection(i) = 0
        end
        
    else    %Run the Gaussian test
        clear eSamples fSamples gSamples hSamples
        clear eComponents fComponents gComponents hComponents

      step = 0.5;
            tic;
        [eSamples, eComponents ] = makeGaussianSamples_Nearest_all_k(75, LinLimits, JALimits,1, 5/180*pi,w, step, Obstacles, oRot, oTrans);
            sampleTime(i) = toc;
        [fComponents fSamples] = removeEmptyComponents(eComponents,eSamples,2);
            pre_compLength(i) = length(fComponents);
        [pre_testConfigCovered, pre_TestQueryConnection, pre_ConnectionTime, pre_PathSearchTime, pre_testWidth ] = PRM_SamplingAnalysis_new(fComponents, fSamples, weigthVec);
        
        %Storing the pre_test result

        pre_TotalCoverage(i,:) = pre_testConfigCovered
        pre_TestResultConnection(:,:,i) = pre_TestQueryConnection;      
        pre_TotalConnectionTime(:,:,i) = pre_ConnectionTime;
        pre_TotalPathSearchTime(:,:,i) = pre_PathSearchTime;
        
        pre_coverage(i) = sum(pre_testConfigCovered)
        
        sumColums = sum(pre_TestQueryConnection);
        pre_sumQueriesConnection(i) = sum(sumColums)

        if pre_compLength(i)>1
            [gSamples, gComponents, difficultWeight, lenInterMedVec] = connectionSampling_new2(fSamples, fComponents, step,w, LinLimits, JALimits, linStepLength, angularStepLength);
            interMedUsed(i) = lenInterMedVec;
            [hComponents hSamples] = removeEmptyComponents(gComponents,gSamples,1);
            post_compLength(i) = length(hComponents);
            [post_testConfigCovered, post_TestQueryConnection, post_ConnectionTime, post_PathSearchTime, post_testWidth ] = PRM_SamplingAnalysis_new(hComponents, hSamples, weigthVec);

            %Storing the post_test result

            post_TotalCoverage(i,:) = post_testConfigCovered
            post_TestResultConnection(:,:,i) = post_TestQueryConnection;
            post_TotalConnectionTime(:,:,i) = post_ConnectionTime;
            post_TotalPathSearchTime(:,:,i) = post_PathSearchTime;

            post_coverage(i) = sum(post_testConfigCovered)

            sumColums = sum(post_TestQueryConnection);
            post_sumQueriesConnection(i) = sum(sumColums)
        else
            disp(' Only one connected component, no merging neccessary.')
            post_TotalCoverage(i,:) = [0 0 0 0 0 0 0 0]
            post_TestResultConnection(1:8,1:8,i) = zeros;
            post_TotalConnectionTime(1:8,1:8,i) = zeros;
            post_TotalPathSearchTime(1:8,1:8,i) = zeros;

            post_coverage(i) = 0

%             sumColums = sum(post_TestQueryConnection);
            post_sumQueriesConnection(i) = 0
        end
    end
       
end
    
