% New PRM planner

function [findPathTime, prePathLength, preNodeNumber, smoothingTime, postPathLength, postNodeNumber, pathPruningTime, pathPruningLength, jointPathTime, jointPathLength ] = PRM_backUp(Components, Samples, weigthVec)

query = 0;
linksN = 10;

initPathName = ['aaInitPath.avi' 'abInitPath.avi' 'acInitPath.avi' 'adInitPath.avi' 'aeInitPath.avi'... 
                'afInitPath.avi' 'agInitPath.avi' 'ahInitPath.avi' 'aiInitPath.avi' 'ajInitPath.avi'...
                'akInitPath.avi' 'alInitPath.avi' 'amInitPath.avi' 'anInitPath.avi' 'aoInitPath.avi'...
                'apInitPath.avi' 'aqInitPath.avi' 'arInitPath.avi' 'asInitPath.avi' 'atInitPath.avi'...
                'auInitPath.avi' 'avInitPath.avi' 'awInitPath.avi' 'axInitPath.avi' 'ayInitPath.avi'];

smoothPathName = ['aaSmoothPath.avi' 'abSmoothPath.avi' 'acSmoothPath.avi' 'adSmoothPath.avi' 'aeSmoothPath.avi'... 
                'afSmoothPath.avi' 'agSmoothPath.avi' 'ahSmoothPath.avi' 'aiSmoothPath.avi' 'ajSmoothPath.avi'...
                'akSmoothPath.avi' 'alSmoothPath.avi' 'amSmoothPath.avi' 'anSmoothPath.avi' 'aoSmoothPath.avi'...
                'apSmoothPath.avi' 'aqSmoothPath.avi' 'arSmoothPath.avi' 'asSmoothPath.avi' 'atSmoothPath.avi'...
                'auSmoothPath.avi' 'avSmoothPath.avi' 'awSmoothPath.avi' 'axSmoothPath.avi' 'aySmoothPath.avi'];

% initPathName = 'absdefghijklmnopqrstuvwxyz';
% smoothPathName = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(4);


% Define som test configurations
TestConfigs(:,1) = [0 38 14 8 -pi/2 60*pi/180 0 0 0 0]';
TestConfigs(:,2) = [0 47 15 0 -pi/2 pi/5 -pi/4 0 0 0]';
% TestConfigs(:,3) = [0 27 32 0 0 pi/5 -pi/4 0 0 0]';
TestConfigs(:,3) = [0 52 28 0 pi/2 20*pi/180 0 0 0 0]';
% TestConfigs(:,4) = [0 40 42 0 pi/2 pi/5 -pi/4 0 0 0]';
TestConfigs(:,4) = [0 40 22 0 -pi/2 20*pi/180 0 0 0 0]';
TestConfigs(:,5) = [0 59 38 4 3*pi/4 -pi/20 -pi/20 0 0 0]';
TestConfigs(:,6) = [0 51 25 6 -pi/2 0 0 0 0 0]';
TestConfigs(:,7) = [0 51 28 4 9*pi/20 pi/20 pi/8 0 0 0]';
TestConfigs(:,8) = [0 63 25 0 pi pi/5 -pi/4 0 0 0]';

[testLen testWidth] = size(TestConfigs);
% testConfigCovered(1,1:testWidth) = zeros;
% TestQueryConnection(testWidth, testWidth) = 0;
% PathSearchTime(testWidth, testWidth) = 0;
% ConnectionTime(testWidth, testWidth) = 0;

for j=1:1 %testWidth-1
    % Start Config
    %     j = startNr;
    %     k = goalNr;
    startCon   = TestConfigs(:,j);
    linValues  = TestConfigs(2:4,j);
    thetaStart = TestConfigs(5:10,j);
    [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);
%     drawRobot(4,[0 1 0], linksN, Manip, lRot, lTrans);

%     for k=(j+1):testWidth
    for k=3:3
        if j~=k || j~=3 || k~=3 

            % Goal Config
            goalCon    = TestConfigs(:,k);
            finalPos   = TestConfigs(2:4,k);
            thetaFinal = TestConfigs(5:10,k);
            [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
%             drawRobot(4,[0 0 1], linksN, Manip, lfRot, lfTrans);

%             tic
%             [startNode, goalNode, newSamples, theComp, successArray]= connectStartGoalNew(startCon, goalCon, Samples, Components, weigthVec, Obstacles, linksN, obsN, oRot, oTrans);
            %             ConnectionTime = toc;
            successArray = [1 0 0];
            
            if ~successArray(3)
                step = 0.5;
                w = weigthVec;
                linStepLength = 1; 
                angularStepLength = 5*pi/180;
                if ~successArray(1)
                    disp('Try bacup on start config')
                    [newSamples, newComponents, backUpSuccess, nodeNr, compNr]  = backUpConnection(startCon, Samples, Components, step,w, LinLimits, JALimits, linStepLength, angularStepLength);
                   if backUpSuccess
                        startNode = nodeNr;
                        [startNode, newSamples, theComp, successArray]= connectGoalNode(goalCon, compNr, newSamples, newComponents, w,  Obstacles, linksN, obsN, oRot, oTrans);
                    successArray(3) = backUpSuccess;
                   end                    
                end
                
                if ~successArray(2)
                    disp('Try bacup on goal config')
                    [newSamples, newComponents, backUpSuccess, nodeNr, compNr]  = backUpConnection(goalCon, Samples, Components, step,w, LinLimits, JALimits, linStepLength, angularStepLength);
                    if backUpSuccess
                        compNr
                        goalNode = nodeNr
                        [startNode, newSamples, theComp, successArray]= connectStartNode(startCon, compNr, newSamples, newComponents, w,  Obstacles, linksN, obsN, oRot, oTrans);
                    successArray(3) = backUpSuccess;
                    end
                end
            end
            
            if successArray(3)
                query = query +1                               
                intiFileName = initPathName(1+((query-1)*14) : (query*14))
                smoothFileName = smoothPathName(1+((query-1)*16) : (query*16))

                prePathNodes =  getShortestPath(startNode, goalNode ,theComp.Node, theComp.NB);
                findPathTime = toc;

                % Extract the entire path                
                prePath = [];
                for i=1:length(prePathNodes(1,:))-1
                    q = prePathNodes(i);
                    qNB = prePathNodes(i+1);
                    Config(1:10,1) = newSamples(1:10,q);
                    Config(1:10,2) = newSamples(1:10,qNB);
                    intermedPath = getSubPath(4, Config,1, 30*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                    intermedPath(11,length(intermedPath(1,:))) = 1;
                    prePath = [prePath intermedPath];
%                     prePath(11,length(prePath)) = 1;
                end

                prePathLength = getPathLength(prePath,weigthVec);
                preNodeNumber = length(prePathNodes);                
                drawPath(prePath, 4, [1 0 0])  
%                  makePathVideo(prePath, 4, [0 1 0],intiFileName)

                %%%%%%%%%%%%% Node Pruning %%%%%%%%%%%%%%%%%%%%%%%%%%
                tic
                postPathNodes = decreasePathNodes(prePathNodes, newSamples, obsN, Obstacles, oRot, oTrans);
                smoothingTime = toc;

                % Find the path
                postPath = [];
                for i=1:length(postPathNodes(1,:))-1
                    Config(1:10,1) = postPathNodes(1:10,i);
                    Config(1:10,2) = postPathNodes(1:10,i+1);
                    intermedPath = getSubPath(4, Config,1, 30*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                    intermedPath(11,length(intermedPath(1,:))) = 1;
                    postPath = [postPath intermedPath];
                    %                     [tempTheta] = interpolAndDraw(Config(1:10,1), Config(1:10,2), 5*pi/180)
                end
                
                postPathLength = getPathLength(postPath,weigthVec);
                postNodeNumber = length(postPathNodes(1,:));
%                 drawPath(postPath, 5, [1 0 0])

                %%%%%%% DETERMINISTIC PATH PRUNING %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                              
                
                tic
                prunedPath = decreasePathDeterministic(postPath,weigthVec, obsN, Obstacles, oRot,oTrans);
                pathPruningTime = toc
                pathPruningLength = (1-(getPathLength(prunedPath,weigthVec))/prePathLength )*100
                drawPath(prunedPath, 6, [1 0 0])
%                  makePathVideo(prunedPath, 6, [1 0 0],smoothFileName)
                
                 %%%%%%% JOINT PRUNING %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

                 tic
                jointPath = decreaseJointPath(postPath,weigthVec, obsN, Obstacles, oRot, oTrans);
                jointPathTime =toc
                jointPathLength = (1-(getPathLength(jointPath,weigthVec))/prePathLength)*100
%                 drawPath(jointPath, 7, [1 0 1])
            else
                findPathTime = toc;

                prePathLength  = 1;
                smoothingTime  = 1;
                postPathLength = 1;
                disp('Found no connection')
            end

        end % End if j~=k
    
    end % endk for loop
end % end j for loop



 %                 The start and goal confgiurations and the waypoints
                %                                  lenPrePath = length(prePath);
                %                                 for i=1:lenPrePath
                %                                     pathSamples(:,i) = newSamples(:, prePath(i));

                %                                     [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] =...
                %                                         makeRobot( newSamples(2:4, prePath(i)), newSamples(5:10, prePath(i)) ); %makeRobot(linValues, theta);
                %
                %                                     if i ==1
                %                                         drawRobot(4,[1 0 0], linksN, Manip, lRot, lTrans)
                %                                     elseif i == lenShortPath
                %                                         drawRobot(4,[0 1 0], linksN, Manip, lRot, lTrans)
                %                                     else
                %                                         drawRobot(4,[1 1 0], linksN, Manip, lRot, lTrans)
                %                                     end

                %                                 end

