% New PRM planner

function [findPATHtime, prePATHLength, preNODENumber, smoothingTIME, postPATHLength, postNODENumber, avPathPruningTime, avPathPruningLength, avPathPruningLengthPost, pathPRUNMin, avJointPathPruningTime, avJointPathPruningLength, avJointPathPruningLengthPost, jointPathPRUNMin ] = PRM_pathSmoothingAnalysis(Components, Samples, weigthVec)
% function  PRM_pathSmoothingAnalysis(Components, Samples, weigthVec)

maxRuns = 100;

query = 0;
linksN = 10;

nodePrunMin =100;
pathPrunMin = 100;
jointPathPrunMin = 100;
% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(4);


% Define som test configurations
TestConfigs(:,1) = [0 38 14 8 -pi/2 60*pi/180 0 0 0 0]';
TestConfigs(:,2) = [0 47 15 0 -pi/2 pi/5 -pi/4 0 0 0]';
% TestConfigs(:,3) = [0 27 32 0 0 pi/5 -pi/4 0 0 0]';
TestConfigs(:,3) = [0 52 28 0 pi/2 20*pi/180 0 0 0 0]';
% TestConfigs(:,4) = [0 40 42 0 pi/2 pi/5 -pi/4 0 0 0]';
TestConfigs(:,4) = [0 40 22 0 -pi/2 20*pi/180 0 0 0 0]';
TestConfigs(:,5) = [0 59 38 4 3*pi/4 -pi/20 -pi/20 0 0 0]';
TestConfigs(:,6) = [0 51 25 6 -pi/2 0 0 0 0 0]';
TestConfigs(:,7) = [0 51 28 4 9*pi/20 pi/20 pi/8 0 0 0]';
TestConfigs(:,8) = [0 63 25 0 pi pi/5 -pi/4 0 0 0]';

[testLen testWidth] = size(TestConfigs);
% testConfigCovered(1,1:testWidth) = zeros;
% TestQueryConnection(testWidth, testWidth) = 0;
% PathSearchTime(testWidth, testWidth) = 0;
% ConnectionTime(testWidth, testWidth) = 0;

for j=1:1 %testWidth-1
    % Start Config
    %     j = startNr;
    %     k = goalNr;
    startCon   = TestConfigs(:,j);
    linValues  = TestConfigs(2:4,j);
    thetaStart = TestConfigs(5:10,j);
    [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);
    %     drawRobot(4,[0 1 0], linksN, Manip, lRot, lTrans);

    for k=(j+1):testWidth
%     for k=5:6
        if j~=k || j~=3 || k~=3
            nodePrunMin =100;
            pathPrunMin = 100;
            jointPrunMin = 100;

            % Goal Config
            goalCon    = TestConfigs(:,k);
            finalPos   = TestConfigs(2:4,k);
            thetaFinal = TestConfigs(5:10,k);
            [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
            %             drawRobot(4,[0 0 1], linksN, Manip, lfRot, lfTrans);

            tic
            [startNode, goalNode, newSamples, theComp, successArray]= connectStartGoalNew(startCon, goalCon, Samples, Components, weigthVec, Obstacles, linksN, obsN, oRot, oTrans);
            %             ConnectionTime = toc;

            if successArray(3)
                query = query +1
                disp('found connection')

                prePathNodes =  getShortestPath(startNode, goalNode ,theComp.Node, theComp.NB)
                findPathTime = toc;
                findPATHtime(query) = findPathTime;

                % Extract the entire path
                prePath = [];
                for i=1:length(prePathNodes(1,:))-1
                    q = prePathNodes(i);
                    qNB = prePathNodes(i+1);
                    Config(1:10,1) = newSamples(1:10,q);
                    Config(1:10,2) = newSamples(1:10,qNB);
                    intermedPath = getSubPath(4, Config,1, 30*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                    prePath = [prePath intermedPath];
                end

                prePathLength = getPathLength(prePath,weigthVec);
                preNodeNumber = length(prePathNodes);
                prePATHLength(query) = prePathLength;
                preNODENumber(query) = preNodeNumber;
                %                 drawPath(prePath, 4, [1 1 0])

                %%%%%%%%%%%%% Node Pruning %%%%%%%%%%%%%%%%%%%%%%%%%%
                tic
                postPathNodes = decreasePathNodes(prePathNodes, newSamples, obsN, Obstacles, oRot, oTrans);
                smoothingTime = toc;
                smoothingTIME(query) = smoothingTime;

                % Find the path
                postPath = [];
                for i=1:length(postPathNodes(1,:))-1
                    Config(1:10,1) = postPathNodes(1:10,i);
                    Config(1:10,2) = postPathNodes(1:10,i+1);
                    intermedPath = getSubPath(4, Config,1, 30*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                    postPath = [postPath intermedPath];
                    %                     [tempTheta] = interpolAndDraw(Config(1:10,1), Config(1:10,2), 5*pi/180)
                end

                postPathLength = getPathLength(postPath,weigthVec);
                postNodeNumber = length(postPathNodes(1,:));
                postPATHLength(query) = (1-(postPathLength/prePathLength))*100;
                postNODENumber(query) = postNodeNumber;
                if postPathLength<nodePrunMin
                    nodePrunMin = postPathLength;
                end
                nodePRUNMin(query) = nodePrunMin;
                %                 drawPath(postPath, 5, [1 0 0])

                %%%%%%% PATH PRUNING %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                for t=1:maxRuns
                    tic
                    prunedPath = decreasePath(postPath,weigthVec, obsN, Obstacles, oRot,oTrans);
                    pathPruningTime = toc;
                    pathPruningLength = getPathLength(prunedPath,weigthVec);

                    if pathPruningLength<pathPrunMin
                        pathPrunMin = pathPruningLength;
                    end
                    pathPRUNINGTime(t,query) = pathPruningTime;
                    pathPRUNINGLength(t,query) =pathPruningLength;
                end

                pathPRUNMin(query) = pathPrunMin;
                avPathPruningTime(query) = sum(pathPRUNINGTime(:,query))/maxRuns;
                avPathPruningLength(query) =  (1-((sum(pathPRUNINGLength(:,query))/maxRuns)/prePathLength) )*100;
                avPathPruningLengthPost(query) =  (1-((sum(pathPRUNINGLength(:,query))/maxRuns)/postPathLength) )*100;


                %                 drawPath(prunedPath, 6, [0 1 1])

                %%%%%%% JOINT PRUNING %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                for t=1:maxRuns
                    tic
                    jointPath = decreaseJointPath(postPath,weigthVec, obsN, Obstacles, oRot, oTrans);
                    jointPathTime =toc;
                    jointPathLength = getPathLength(jointPath,weigthVec);

                    if jointPathLength<jointPathPrunMin
                        jointPathPrunMin = jointPathLength;
                    end
                    jointPathPRUNINGTime(t,query) = jointPathTime;
                    jointPathPRUNINGLength(t,query) =jointPathLength;
                end

                jointPathPRUNMin(query) = jointPathPrunMin;
                avJointPathPruningTime(query) = sum(pathPRUNINGTime(:,query))/maxRuns;
                avJointPathPruningLength(query) =  (1-(sum(pathPRUNINGLength(:,query))/maxRuns)/prePathLength )*100;
                avJointPathPruningLengthPost(query) =  (1-(sum(pathPRUNINGLength(:,query))/maxRuns)/postPathLength )*100;
                %                 drawPath(jointPath, 7, [1 0 1])
            end
        else
            findPathTime = toc;

            prePathLength  = 1;
            smoothingTime  = 1;
            postPathLength = 1;
            disp('Found no connection')
        end

    end % End if j~=k
end % endk for loop
end % end j for loop



 %                 The start and goal confgiurations and the waypoints
                %                                  lenPrePath = length(prePath);
                %                                 for i=1:lenPrePath
                %                                     pathSamples(:,i) = newSamples(:, prePath(i));

                %                                     [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] =...
                %                                         makeRobot( newSamples(2:4, prePath(i)), newSamples(5:10, prePath(i)) ); %makeRobot(linValues, theta);
                %
                %                                     if i ==1
                %                                         drawRobot(4,[1 0 0], linksN, Manip, lRot, lTrans)
                %                                     elseif i == lenShortPath
                %                                         drawRobot(4,[0 1 0], linksN, Manip, lRot, lTrans)
                %                                     else
                %                                         drawRobot(4,[1 1 0], linksN, Manip, lRot, lTrans)
                %                                     end

                %                                 end

