% New PRM planner

function [ConnectionTime, PathSearchTime, intermediatePath ] = PRM_pathTest(Components, Samples, weigthVec, startNr, goalNr)

% clear PathSearchTime
% clear ConnectionTime
% testConfigCovered(1,1:6) = zeros;
% TestQueryConnection (1,1) = 0;
figure(4)
hold off
plot3(0,0,0,'o')
hold on

linksN = 10;

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeAndDrawObstacles(4);

% Define som test configurations
TestConfigs(:,1) = [0 38 14 8 -pi/2 60*pi/180 0 0 0 0]';
TestConfigs(:,2) = [0 47 15 0 -pi/2 pi/5 -pi/4 0 0 0]';
% TestConfigs(:,3) = [0 27 32 0 0 pi/5 -pi/4 0 0 0]';
TestConfigs(:,3) = [0 52 28 0 pi/2 20*pi/180 0 0 0 0]';
% TestConfigs(:,4) = [0 40 42 0 pi/2 pi/5 -pi/4 0 0 0]';
TestConfigs(:,4) = [0 40 22 0 -pi/2 20*pi/180 0 0 0 0]';
TestConfigs(:,5) = [0 59 38 4 3*pi/4 -pi/20 -pi/20 0 0 0]';
TestConfigs(:,6) = [0 51 25 6 -pi/2 0 0 0 0 0]';
TestConfigs(:,7) = [0 51 28 4 9*pi/20 pi/20 pi/8 0 0 0]';
TestConfigs(:,8) = [0 63 25 0 pi pi/5 -pi/4 0 0 0]';

[testLen testWidth] = size(TestConfigs);
testConfigCovered(1,1:testWidth) = zeros;
TestQueryConnection(testWidth, testWidth) = 0;
PathSearchTime(testWidth, testWidth) = 0;
ConnectionTime(testWidth, testWidth) = 0;

    % Start Config
    j = startNr;
    k = goalNr;
    startCon   = TestConfigs(:,j);
    linValues  = TestConfigs(2:4,j); 
    thetaStart = TestConfigs(5:10,j); 
    [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);
    drawRobot(4,[0 1 0], linksN, Manip, lRot, lTrans);
    
        if j~=k             
            
            % Goal Config
            goalCon    = TestConfigs(:,k);
            finalPos   = TestConfigs(2:4,k); 
            thetaFinal = TestConfigs(5:10,k); 
            [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
            drawRobot(4,[0 0 1], linksN, Manip, lfRot, lfTrans);
            
            
            %%%%% Need some kind of timer here %%%%%%%%
            tic
            [startNode, goalNode, newSamples, theComp, successArray]= connectStartGoal(startCon, goalCon, Samples, Components, weigthVec, Obstacles, linksN, obsN, oRot, oTrans);
            ConnectionTime = toc;        
            
            if successArray(3)
                disp('found connection')
                
                tic
                shortPath =  getShortestPath(startNode, goalNode ,theComp.Node, theComp.NB);
                PathSearchTime = toc;
                
                lenShortPath = length(shortPath);
              
                for i=1:lenShortPath
                    pathSamples(:,i) = newSamples(:, shortPath(i));

                    [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] =...
                        makeRobot( newSamples(2:4, shortPath(i)), newSamples(5:10, shortPath(i)) ); %makeRobot(linValues, theta);

                    if i ==1
                        drawRobot(4,[1 0 0], linksN, Manip, lRot, lTrans)
                    elseif i == lenShortPath
                        drawRobot(4,[0 1 0], linksN, Manip, lRot, lTrans)
                    else
                        drawRobot(4,[1 1 0], linksN, Manip, lRot, lTrans)
                    end

                end
                tic
                shortPathSamples = decreasePathNodes(pathSamples, obsN, Obstacles, oRot, oTrans);
                tNode = toc
            
                % Find the path
                intermediatePath = [];
                for i=1:length(shortPathSamples(1,:))-1
                    disp(['Drawing config: ' int2str(shortPath(i)) ]);
                    Config(1:10,1) = shortPathSamples(1:10,i);
                    Config(1:10,2) = shortPathSamples(1:10,i+1);
                    intermedPath = getSubPath(4, Config,1, 60*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                    intermediatePath = [intermediatePath intermedPath];
                  %[tempTheta] = interpolAndDraw(Config(1:10,1), Config(1:10,2), 5*pi/180)
                end   
                
%                 % Find the path
%                 intermediatePath = [];
%                 for i=1:length(shortPath)-1
%                     disp(['Drawing config: ' int2str(shortPath(i)) ]);
%                     Config(1:10,1) = newSamples(1:10, shortPath(i) );
%                     Config(1:10,2) = newSamples(1:10, shortPath(i+1) );
%                     intermedPath = getSubPath(4, Config,1, 60*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
%                     intermediatePath = [intermediatePath intermedPath];
%                   %[tempTheta] = interpolAndDraw(Config(1:10,1), Config(1:10,2), 5*pi/180)
%                 end               
                                
                
                % Draw the entire path
%                 for i= 1:length(intermediatePath)                      
%                     [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] =...
%                     makeRobot( intermediatePath(2:4,i), intermediatePath(5:10,i) ) ;%makeRobot(linValues, theta);
%                     drawRobot(4,[1 0 0], linksN, Manip, lRot, lTrans)
%                 end
                
               pathLength = getPathLength(intermediatePath,weigthVec)
               
               tic
               jointPath = decreaseJointPath(intermediatePath,weigthVec, obsN, Obstacles, oRot, oTrans);
               tt=toc
               
               jointPathLength = getPathLength(jointPath,weigthVec)
               
               tic 
               path = decreasePath(intermediatePath, obsN, Obstacles, oRot,oTrans);
               t=toc
               
               newPathLength = getPathLength(path,weigthVec)
               
               figure(5)
               hold off
               plot3(0,0,0,'o')
               hold on
               
               [Obstacles oT oRot oTrans obsN] = makeAndDrawObstacles(5);
               
%                for i= 1:length(path)                      
%                     [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] =...
%                     makeRobot( path(2:4,i), path(5:10,i) ) ;%makeRobot(linValues, theta);
%                     drawRobot(5,[1 0 0], linksN, Manip, lRot, lTrans)
%                 end
                
            else
                disp('Found no connection')
            end

        end % End if j~=k





