% Binary Collision Test between two configurations

function [inter] = binCollisionCheck(Config,maxStep,linksN, obsN, Manip,Man, Obstacles, oRot, oTrans)
inter = false;
interval =100;
teller = 1;

while interval>maxStep

    clear newConfig
    newConfig = Config(1:linksN,1);
    [not n] = size(Config);
    
    for i =1:n-1

        mid = Config(1:linksN,i+1) + ( ( Config(1:linksN,i)-Config(1:linksN,i+1) )/2);

        tempDH = [mid(1)       6.15  1.00  -pi/2
            mid(2)-pi/2  0.00  7.05  0
            mid(3)       0.00  1.35  -pi/2
            mid(4)       7.55  0.00  pi/2];

        % Making transformation matrices for the joint frames
        [tempfT, tempfRot, tempfTrans ] = dh(tempDH);
        % Making transformation matrices for the links
        [templT, templRot, templTrans ] = dhLinkABB(tempfT,Manip,Man);
        
%         figure(3)
%         hold on
%         [xlink1f ylink1f zlink1f] = linkTransf( Manip(1,1), Manip(1,2), Manip(1,3) , templRot(:,:,1), templTrans(:,:,1) );
%         [xlink2f ylink2f zlink2f] = linkTransf( Manip(2,1), Manip(2,2), Manip(2,3) , templRot(:,:,2), templTrans(:,:,2) ); 
%         [xlink3f ylink3f zlink3f] = linkTransf( Manip(3,1), Manip(3,2), Manip(3,3) , templRot(:,:,3), templTrans(:,:,3) ); 
%         [xlink4f ylink4f zlink4f] = linkTransf( Manip(4,1), Manip(4,2), Manip(4,3) , templRot(:,:,4), templTrans(:,:,4) );
% 
%         % Drawing the maipulttor in its final pose
%         patch(xlink1f, ylink1f, zlink1f, [1 0 0]);
%         patch(xlink2f, ylink2f, zlink2f, [1 0 0]);
%         patch(xlink3f, ylink3f, zlink3f, [1 0 0]);
%         patch(xlink4f, ylink4f, zlink4f, [1 0 0]);

        if collisionCheck(linksN, obsN, Manip, templRot, templTrans, Obstacles, oRot, oTrans);
%             disp('Her var det kollisjon gitt');
            inter = true;
            return
        else
            newConfig = [newConfig mid Config(1:linksN,i+1)];
        end


    end
    interval =  max(abs(newConfig(1:linksN,1) - newConfig(1:linksN,2) ) );
    Config = newConfig;
    clear newConfig;
    teller = teller +1;
    
    if teller>100
        error('tull i feilen')
    end
        
end
