% 3D Path Planning and visualization
% clear all;
% figure(1)
% hold off
% plot3(0,0,0,'o')
% hold on

% function [success linValues theta] = connectToPointPlanner(goalPoint, linValues, thetaStart,Obstacles, oRot, oTrans, obsN,fig)
function [success linValues theta] = connectToPointPlannerOrient(goalPoint,goalPoint2, linValues, thetaStart,fig)
success = false;
%% Initalizing
zeta = [0 0 0 0 0 0 0 0 2 2];     % Uatt potential field factor
obsLimit = 5;            % Limit for Urep potential field
goalLimit = 4;            % Limit for conic potential field
eta = 10;                  % Urep potential field factor
w = [1 1 1 1]';           % Distance weight  
alpha =0.1;               % step length in descent algorithm
beta = 0.5;                 % step length in descent algorithm  

epsi = 1;
% epsiLin = 12*[ 0.1 0.1 0.1]';
% epsiTheta = 5*[0.1 0.1 0.1 0.1 0.1 0.1];
mainRuns = 20 ;%60;
figure(fig)
hold off
plot3([goalPoint2(1) goalPoint(1)], [ goalPoint2(2) goalPoint(2)], [goalPoint2(3) goalPoint(3)], 'r')
hold on
plot3(goalPoint(1), goalPoint(2), goalPoint(3), 'y o')

%% Making some obstacles 

[Obstacles oT oRot oTrans obsN] = makeAndDrawObstacles(fig);

%% Making the the robot

linksN=10;

% Makes the robot in final position
% finalPos = [-5 -3 -4]';
% thetaFinal = [pi/3 -pi/5 -pi/7 pi/4 pi/4 pi/6];

% [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);



% Makes the  robot in its initial position  
    %%%%%% Initial pose %%%%%%%
% linValues = [5 -2 -0.5]';     
% thetaStart = [pi/3 pi/6 -pi/6 pi/8 -pi/4 pi/6]';

[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);
linValues = [DH(2,2) DH(3,2) DH(4,2)]';
theta = [DH(5,1) DH(6,1) DH(7,1) DH(8,1) DH(9,1) DH(10,1)]';
%%%%%%% Starting the for loop to compute the path %%%%%%
%% Starting the for loop

for i=1:mainRuns% 95 funker fint
    
        if( norm(fT(1:3,4,10)-goalPoint ) < epsi && ...
            norm(fT(1:3,4, 9)-goalPoint2) < epsi )
%             abs(linValues(1)-finalPos(1))< epsiLin(1) && ... 
%            abs(linValues(2)-finalPos(2))< epsiLin(2) && ...
%            abs(linValues(3)-finalPos(3))< epsiLin(3) && ...
%            abs(theta(1)-DenHaf(5,1))< epsiTheta(1) && ...
%            abs(theta(2)-DenHaf(6,1))< epsiTheta(2) && ...
%            abs(theta(3)-DenHaf(7,1))< epsiTheta(3) && ...
%            abs(theta(4)-DenHaf(8,1))< epsiTheta(4)  
%            abs(theta(5)-DenHaf(9,1))< epsiTheta(5) && ...
%            abs(theta(6)-DenHaf(10,1))< epsiTheta(6)
            disp('Done!')
            success = true;
            break;
        end
%     hallo = hallo + 1;
    % Making transformation matrices for the joint frames
    [fT, fRot, fTrans ] = dh(DH);
    % Making transformation matrices for the links
    [lT, lRot, lTrans ] = dhLinkABBSystem(fT,Manip,Man);  
    
    drawRobot(fig,[0 1 0], linksN, Manip, lRot, lTrans)

%% Calculate the transposed Jacobian of "fixed" length

    fJacobianABBT(:,:,5) = jacABBT01(fT);  
    fJacobianABBT(:,:,6) = jacABBT02(fT);  
    fJacobianABBT(:,:,7) = jacABBT03(fT);
    fJacobianABBT(:,:,8) = jacABBT04(fT);
    fJacobianABBT(:,:,9) = jacABBT05(fT);
    fJacobianABBT(:,:,10) = jacABBT06(fT);
    
%% Calculating the Attractive field (only for end effector?)
    attTorque(1:linksN-4,1) =zeros;
    for k=9:10; % Calculates only the attractive force for the end effector 
        
        dist = norm ( goalPoint-fT(1:3,4,k) );
        
        if dist < goalLimit
            Uatt(:,k) = 0.5*zeta(k)*(dist^2);       % ( not really in use )
            pa(:,k)  = -zeta(k)*( fT(1:3,4,k) - goalPoint );
        else
            %Uatt(:,k)=goalLimit*0.5*zeta(k)*dist - 0.5*zeta*(goalLimit^2);
            Uatt(:,k) =  goalLimit*0.5*zeta(k)*dist; % (not really in use)
            pa(:,k)   = -goalLimit*0.5*zeta(k)*( fT(1:3,4,k) - goalPoint )/dist;
        end
        % calculating torque    
            attTorque = attTorque + fJacobianABBT(:,:,k)*pa(:,k);
    end
        
   attForce = pa(:,10); % ***********hm e dette rett? pa(:,2)+pa(:,3)+pa(:,4)
%% Calculating closest distances between links and obstacles 
 
    it = 0;
    repTorque(1:linksN-4,1) = zeros;
    repulsiveForce = [0 0 0]';
    for l=4:linksN %Starting in the frame attached to the vertical bar       
        for o =1:obsN
            it = it+1;
             %Starting the GJK algorithm
             %Initializing
            
              % Finding an initial vector inside A-B using the Supportpoints             
             avec = [ 2 6 3]';
             wR   = supportPoint(-avec,  Manip(l,:), lRot(:,:,l), lTrans(:,:,l));   
             wObs = supportPointCyl(avec, Obstacles(o,1), Obstacles(o,2), oRot(:,:,o), oTrans(:,:,o));  
             
             a = wR-wObs; 
             
             bvec = [ 2 -6 3]';
             wR   = supportPoint(-bvec,  Manip(l,:), lRot(:,:,l), lTrans(:,:,l));   
             wObs = supportPointCyl(bvec, Obstacles(o,1), Obstacles(o,2), oRot(:,:,o), oTrans(:,:,o));  
             b = wR-wObs;             
             
             c = a-b;
             vInit = b + 0.5*c;       

             %Extract the disatance, direction, closest point on R obstacle
             [inter dist v r obs ] = gjkBoxCyl(vInit, Manip(l,:), lRot(:,:,l), lTrans(:,:,l), Obstacles(o,1), Obstacles(o,2), oRot(:,:,o), oTrans(:,:,o) );
             
              if inter==1   
                 plot3([r(1) obs(1)], [r(2) obs(2)], [r(3) obs(3)],'r');
                 plot3(r(1),r(2),r(3),'h k');
                 plot3(obs(1),obs(2),obs(3),'h k');
%                  disp(' **************INTERSECTION***************************************************************************************')
                 break;
             end
             
             if dist<0.001
                 inter =true;
                 break;
%                  dist
%                  error(' possible intersection')
                
             end              
             
             %%%%%%%% Calculate the "variable" transposed Jacobian %%%%%  
             if l ==5                           
                 JacobianABBTVar(:,:,5) = jacABBT01Var(fT,r);                
             elseif l==6                  
                 JacobianABBTVar(:,:,6) = jacABBT02Var(fT,r);
             elseif l==7    
                 JacobianABBTVar(:,:,7) = [0 0 0 
                                           0 0 0 
                                           0 0 0 
                                           0 0 0
                                           0 0 0
                                           0 0 0];
             elseif l==8
                 JacobianABBTVar(:,:,8) = jacABBT04Var(fT,r);
             elseif l==9
%                 JacobianABBTVar(:,:,9) = jacABBT05Var(fT,r);
                 JacobianABBTVar(:,:,9) = [0 0 0 
                                           0 0 0 
                                           0 0 0 
                                           0 0 0
                                           0 0 0
                                           0 0 0];
             elseif l==10
                 JacobianABBTVar(:,:,10) = jacABBT06Var(fT,r);
                 
               
             end
             
             %%%%%%% Calculate the Repulisve field %%%%%%
             if dist < obsLimit
                 Ur = 0.5*eta*(( 1/dist - 1/obsLimit )^2);                 
                 repForce = -eta*( 1/obsLimit - 1/dist ) * ( 1/(dist^2) ) * ((r-obs )/dist); % * (( Y(i,j)-obst(2) )/Dist(i,j));
                 if l>4
                    repTorque = repTorque + JacobianABBTVar(:,:,l)* repForce';                         
                 else
                    repulsiveForce = repulsiveForce + repForce' ;
                 end
             end             
        end 
             if inter==1                 
%                  disp(' **************INTERSECTION***************')
                 break;
             end             
    end
    if inter==1                 
        disp(' **************INTERSECTION***************')
        break;
    end
%% Summarize attractive and repulsive torques
    
    sumLinForces = attForce + repulsiveForce;
    sumTorque = attTorque + repTorque;
    
     % Check if torque exceeds torque limit
%     for k=1:linksN       
%         if sumTorque(k)>torqueLimit(k)
%             sumTorque(k) = torqueLimit(k)
%         elseif -sumTorque(k)>torqueLimit(k)
%             sumTorque(k) = -torqueLimit(k)
%         end
%     end     
%%  Updating the new theta values

    linValues = linValues + beta*sumLinForces/norm(sumLinForces);
    
    theta = theta + alpha*sumTorque/norm(sumTorque);
    
    [linValues, theta]=limitCheck(linValues, theta, LinLimits, JALimits);

    DH(2,2)  = linValues(1); % x
    DH(3,2)  = linValues(2); % y
    DH(4,2)  = linValues(3); % z
    DH(5,1)  = theta(1);
    DH(6,1)  = theta(2);
    DH(7,1)  = theta(3);
    DH(8,1)  = theta(4);
    DH(9,1)  = theta(5);
    DH(10,1) = theta(6);
        
end    
    
    
  

