function [newSamples, newComponents, difficultWeight] = connectionSampling(Samples, Components, step,w, LinLimits, JALimits, linStepLength, angularStepLength)

sumDegInverse=0;
lenSamples = length(Samples);
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(1);
linksN=10;
failed = 0;

% Calculateing the weights
for q=1:lenSamples
    
    comp = Samples(11,q);
    if length(Components(comp).NB)>1
        tempVec = find(Components(comp).NB(q,:));
        deg(q) = length(tempVec);
        sumDegInverse = sumDegInverse + ( 1/(deg(q)+1) );
    else
        deg(q) = 0;
        sumDegInverse = sumDegInverse + ( 1/(deg(q)+1) );
    end
end

for q=1:lenSamples
    difficultWeight(q,1) = 1 /( (deg(q)+1)*sumDegInverse );
    difficultWeight(q,2) = q;
%     difficultWeight(q,3) = Samples(11,q);
end

sortMat = sortRows(difficultWeight,-1)
mergedComp = [];

numberOfComponents = length(Components)

for i=1:lenSamples
    i
    if length(mergedComp) == (numberOfComponents-1) ||i ==3
        newSamples = Samples;
        newComponents = Components;
       disp('Done merging all components')
        return;
    end
    q = sortMat(i,2);    % Extracting the node number
    diffCompNumber = Samples(11,q) % which belongs to compoment comp
    maxRun = 1;
    connectSuccess = false;
%     if isempty(find(mergedComp==diffCompNumber)) % Check that component not allready merged
        
        while ~connectSuccess && maxRun<=10

            [nbConfig jointAngles] = moveRandStep(step,w, Samples(1:10,q), LinLimits, JALimits);

            Config(:,1) = nbConfig;
            Config(:,2) = Samples(1:10,q);

            % Try to connect the components
            if ~binCollisionCheckABB(Config,linStepLength, angularStepLength, linksN, obsN, Obstacles, oRot, oTrans)
                disp('Found and connected neigbour configuration')
                % If connection succeeded, try connect neighbour to other component
                maxRun = maxRun +1;
                % Calculate the closest distance to all samples from q':
%                              clear TempMat;
                tellerTo = 1;
                for teller = 1:lenSamples
%                   isempty(find(Components(diffCompNumber).Node==teller))
                    if isempty(find(Components(diffCompNumber).Node==teller))
                        TempMat(tellerTo,:) = [configDist(nbConfig, Samples(1:10,teller), w ),teller ];
                        tellerTo = tellerTo +1;
                    end
                end

                % Sort the matrix with increasing distance
                %                 clear sortMat;
                sortNodeMat = sortrows(TempMat);
                
                % Try make a connection between current node
                % and closest node
                [rows col] = size(sortNodeMat);
                %                 if rows>K
                %                     rows = K;
                %                 end

                %                 Config(1:10,1) = [0; linValues; theta ];
                % Try all nodes in the graph
                
                for ind=1:rows
                    connectToNode = sortNodeMat(ind,2);
                    connectCompNumber = Samples(11,connectToNode);
                    %                                     Config(1:10,1) = [0; linValues; theta ];
                    Config(1:10,2) = Samples(1:10, connectToNode);
                    interaction = binCollisionCheckABB( Config,linStepLength, angularStepLength,linksN, obsN, Obstacles, oRot, oTrans);
                    if ~interaction % If no interaction, add the node to the component
                        connectDist = sortNodeMat(ind,1);
                        [connectSuccess Samples Components mergedComp]= mergeComponents(Samples, Components, nbConfig, diffCompNumber, connectCompNumber, connectToNode, connectDist, mergedComp);
                        %                         (diffCompNumber,  connectCompNumber, connectToNode, connectDist  )
%                         [ connectSuccess Samples comp emptyComp] = mergeComponents(con, c, ind, Samples, comp, sortNodeMat, emptyComp);
                        if connectSuccess % Node added to component break for loop
                            break;
                        end
                    end
                end % If no connection found , try next sample.
                if connectSuccess == false % If neighbour fails to conncet to any node
                    failed = failed + 1
                    % Store the neigbour connection
                    nbSmaples(:,failed) = nbConfig;
                    nbSampels(11,failed)= diffCompNumber; 
                end
            end
%             clear sortNodeMat;
%             clear TempMat;
        end
%     else
%         disp('components allready connected')
%     end

end

newSamples = 0;
newComponents =0;

disp('Failed to merge all components')