function [newSamples, newComponents, difficultWeight, interMedVec] = connectionSampling_Comp(Samples, Components, step,w, LinLimits, JALimits, linStepLength, angularStepLength)

sumDegInverse=0;
lenSamples = length(Samples);
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(1);
linksN=10;
% failed = 0;

% Calculateing the weights
for q=1:lenSamples
    
    comp = Samples(11,q);
    if length(Components(comp).NB)>1
        tempVec = find(Components(comp).NB(q,:));
        deg(q) = length(tempVec);
        sumDegInverse = sumDegInverse + ( 1/(deg(q)+1) );
    else
        deg(q) = 0;
        sumDegInverse = sumDegInverse + ( 1/(deg(q)+1) );
    end
end

for q=1:lenSamples
    difficultWeight(q,1) = 1 /( (deg(q)+1)*sumDegInverse );
    difficultWeight(q,2) = q;
%     difficultWeight(q,3) = Samples(11,q);
end

sortMat = sortRows(difficultWeight,-1);
mergedComp = [];
interMedVec = [];

numberOfComponents = length(Components);

for i=1:50  %1:lenSamples
    i
    emptyComponents = 0;
    for k=1:numberOfComponents
        if isempty(Components(k).Node)
            emptyComponents = emptyComponents + 1;
        end
    end
    if emptyComponents == (numberOfComponents -1)      
        newSamples = Samples;
        newComponents = Components;
        disp('Done merging all components')
        return;
    end
    q = sortMat(i,2);    % Extracting the node number
    diffCompNumber = Samples(11,q); % which belongs to compoment comp
    nbTried = 0;
    maxNbTried = 80;
    nbFailed =0;
    maxNbFailed = 10;
    totalNBs = 1;
    maxTotalNBs = 10;
    interMed = false;
    interMediateSample(1:11,1) = zeros;
    clear interMediateSample
%     clear interMedStruct
    connectSuccess = false;
    difficultConfig = Samples(1:10,q);
    %     if isempty(find(mergedComp==diffCompNumber)) % Check that component not allready merged

    while ~connectSuccess %&& maxRun<=10
        
        nbTried = nbTried +1;
        if nbTried==maxNbTried    %   (Kan vre ett noks stort tall)
            disp('Give up this node, try a new')
            break; %(bryter av while loopen, fortsetter for loopen)
        end

        [nbConfig jointAngles] = moveRandStep(step,w, difficultConfig, LinLimits, JALimits);

        Config(:,1) = nbConfig;
        Config(:,2) = difficultConfig;

        % Try to connect the components
        if ~binCollisionCheckABB(Config,linStepLength, angularStepLength, linksN, obsN, Obstacles, oRot, oTrans)
%             disp('Found and connected neigbour configuration')
            % If connection succeeded, try connect neighbour to other component
            nbTried = 0;
            % Calculate the closest distance to all samples from q':
            %                              clear TempMat;
            tellerTo = 1;
            for teller = 1:lenSamples
                %                   isempty(find(Components(diffCompNumber).Node==teller))
                if isempty(find(Components(diffCompNumber).Node==teller))
                    TempMat(tellerTo,:) = [configDist(nbConfig, Samples(1:10,teller), w ),teller ];
                    tellerTo = tellerTo +1;
                end
            end
            
            % Sort the matrix with increasing distance
            %                 clear sortMat;
            sortNodeMat = sortrows(TempMat);

            % Try make a connection between current node
            % and closest node
            [rows col] = size(sortNodeMat);
            %                 if rows>K
            %                     rows = K;
            %                 end

            %                 Config(1:10,1) = [0; linValues; theta ];
            % Try all nodes in the graph

            for ind=1:rows
                connectToNode = sortNodeMat(ind,2);
                connectCompNumber = Samples(11,connectToNode);
                
                if connectCompNumber~=diffCompNumber
                %                                     Config(1:10,1) = [0; linValues; theta ];
                Config(1:10,2) = Samples(1:10, connectToNode);
                interaction = binCollisionCheckABB( Config,linStepLength, angularStepLength,linksN, obsN, Obstacles, oRot, oTrans);
                if ~interaction % If no interaction, add the node to the component
                    connectDist = sortNodeMat(ind,1);
                    if interMed
                        [connectSuccess Samples Components mergedComp]= mergeComponents(Samples, Components, nbConfig, diffCompNumber, connectCompNumber, connectToNode, 0, mergedComp);                        
                        if connectSuccess

                            tempLenSamples=length(Samples);
                            lenInterMed = length(interMediateSample); % Does not include the last NB sample
                            theComp = Samples(11,tempLenSamples);    
                            tempSample(1:11,1) = Samples(:,tempLenSamples);
                            
%                             Components(theComp).NB(tempLenSamples, connectToNode) = 0;
%                             Components(theComp).NB(connectToNode, tempLenSamples) = 0;

                            Samples(1:11,tempLenSamples:(tempLenSamples+lenInterMed-1) ) = interMediateSample;

                            for k =1:lenInterMed+1
                                index = tempLenSamples+k-1;
%                                 Samples(1,10,index) = interMediateSample(1:10,k);
%                                 Samples(11,index )   = theComp;
                                Components(theComp).Node = [Components(theComp).Node index];
                                interMedVec = [interMedVec; index];
                                if k==1
                                    Components(theComp).NB(index, q) = step;
                                    Components(theComp).NB(q, index) = step;                                                                      
                                else
                                    Components(theComp).NB(index, index-1) = step;
                                    Components(theComp).NB(index-1, index) = step;
                                end
                                
                            end
                            Samples(1:11,tempLenSample+lenInterMed) = tempSample;
                            Components(theComp).NB(tempLenSample+lenInterMed, connectToNode) = connectDist;
                            Components(theComp).NB(connectToNode, tempLenSample+lenInterMed) = connectDist;
                            
                            disp('Her var det ett intermed tilfelle gitt...')
                            interMed = 0;
                            break;
                        end
                        
                    else
                        [connectSuccess Samples Components mergedComp]= mergeComponents(Samples, Components, nbConfig, diffCompNumber, connectCompNumber, connectToNode, connectDist, mergedComp);
                    end
                    
                    if connectSuccess % Node added to component break for loop
                        break;
                    end
                end
                else
                    disp('Tried to connect to same component')
                end
            end % If no connection found , try next sample.
            if ~connectSuccess            
                    nbFailed = nbFailed +1;
            end
%             if connectSuccess == false % If neighbour fails to conncet to any node
                
                if nbFailed == maxNbFailed
                    
%                     if interMed
%                         interMedStruct.Node = [interMedStruct.Node; totalNBs]';
%                         interMedStruct.NB = [interMedStruct.NB; totalNBs-1]';
%                         interMedStruct.Nb = [interMedStruct.NBdist; step]';
%                     else
%                         interMedStruct = stuct('Node',[totalNBs], 'NB',[q], 'NBdist',[step] );
%                     end
                    disp('Reached Fail')
                    difficultConfig = nbConfig;
                    interMediateSample(1:10,totalNBs) = nbConfig;
                    interMediateSample(11,totalNBs) = diffCompNumber
                    interMed = true;	%(M lage en egen versjon i connectNodeABB...)
                    nbFailed = 0;
                    nbTried = 0;
                    totalNBs = totalNBs + 1;

                    if totalNBs == maxTotalNBs
                        disp('Reached finale Fail!')
                        break;  %(Break while loop)
                    end
                end

%                 if finaleFailed == maxFinaleFailed
%                     disp('Reached finale Fail!')
%                     difficultConfig = Samples(:,q);
%                     finaleFailed = 0;
%                     break; % Break the while loop
%                 end
                    
                % Store the neigbour connection
%                 nbSmaples(:,failed) = nbConfig;
%                 nbSampels(11,failed)= diffCompNumber;

%             end
                        clear sortNodeMat;
                        clear TempMat;
        end
        %     else
        %         disp('components allready connected')
    end

end

newSamples = Samples;
newComponents =Components;

disp('Failed to merge all components')