%function [X1, Y1, Z1] = makeCylinder(r, len, rot, trans)

Obstacles = [2 4];   
r = 2.5;
len = 40;
               
ObsMat= [  pi/3    pi/6    0   3   -5  0];

    %Making transformation Matrices for the obstacles
[oT oRot oTrans] = obsTransformation(ObsMat);

rot =oRot;
trans=oTrans;

    %  making a unit cylinder of radius r
n=10;    
[X, Y, Z] = cylinder(r,n);

    % align it around zero
len = len/2;
Z(1,1:n+1) = ones*len;
Z(2,1:n+1) = -ones*len;
    
    %Specify the cylinder color
Color(1, 1:n+1) = ones*1;
Color(2, 1:n+1) = ones*2;

    % rotate and translate the cylinder
big = size(X);
for i=1:big(1)
        for j=1:big(2)
            
            vec = rot*[X(i,j) Y(i,j) Z(i,j)]' + trans;
            
        X1(i,j) = vec(1);
        Y1(i,j) = vec(2); 
        Z1(i,j) = vec(3); 
        end
          
end

v= [1 0 -1]';
radius = r;
rRot =oRot;
rTrans=oTrans;

% rotating the vector
vec = rRot'*v;
% calculating the distance to the z-axis
sigma = (vec(1)^2 + vec(2)^2 )^0.5;

if vec(3) ==0
    vec(3) = 1
end

if sigma >0
    supPoint = [radius/sigma*vec(1) radius/sigma*vec(2)  sign(vec(3))*len ]';
else
    supPoint = [0 0 sign(vec(3))*len ]';
end

% transfering the support point back to original position
    supPointTransformed = rRot*supPoint + rTrans;

figure(3)
axis([-20 20 -20 20 -20 20]);      
hold on
surf(X1, Y1, Z1, Color );
plot3(supPointTransformed(1),supPointTransformed(2), supPointTransformed(3),'y h' );
hold off