% Using Dijkstra's algorithm to find shortest path from start to goal

function [shortPath] =  getShortestPath(start,goal,validNodes,Graph)

% checks that start and goal nodes is in the component.

if isempty( find(validNodes==start) )  
    error('Start node not found in this configuration');
elseif isempty( find(validNodes==goal) )
    error('Goal node not found in this configuration ');
end

% Initializing the querey list      
PriQ(1:length(Graph),1) = inf;
PriQ(1:length(Graph),2) = 1:length(Graph); 
PriQ(1:length(Graph),3) = inf;
PriQ(start,1) = 0;
smallInd = 1;
PriQsort = sortrows(PriQ);


for i =1:length(PriQ)
    
    % Choose the lowest allowed node in the query list
    currentNode = PriQsort(smallInd,2);
    
%     if ~isempty(find(validNodes==currentNode))
    % Update the node struct containing final data    
    if i==1
    nodeSt = struct('Node', [currentNode], 'Dist',[0], 'Parent', [0]);
    else
    nodeSt.Node = [nodeSt.Node currentNode];
    nodeSt.Dist = [nodeSt.Dist PriQ(currentNode,1)];
    nodeSt.Parent = [nodeSt.Parent PriQ(currentNode,3)];
    end
    
    % If current node = goal node, shortest path is found
    if currentNode == goal
%         disp('shortest path found')
        break;
    end
 
    % If reached end of nodes, break
    if i == length(PriQ)
        disp('shortest path NOT found')
        break
    end
    % Find the current node neighbours
    ind = 1;
    neighbours = [];
    for j = 1:length(Graph(:,currentNode))
        if Graph(j,currentNode) > 0 && isempty(find(nodeSt.Node==j))
                neighbours(ind) = j;
                ind = ind + 1;
        end        
    end 
%     if currentNode==15
%         disp(['Naboene til 15 er: ' int2str(neighbours)])
%     end
%     
%     if ~isempty(find(neighbours==15))
%         disp(['Naboene er: ' int2str(neighbours)])
%     end
    % Add distances
    for j=1:length(neighbours)
        newDist = nodeSt.Dist(i) + Graph(currentNode, neighbours(j) );
        if newDist<PriQ(neighbours(j),1)
            PriQ(neighbours(j),1) = newDist;
            PriQ(neighbours(j),3) = currentNode;
        end
    end
    
    % sort the new priority queue 
    PriQsort = sortrows(PriQ);
%     end
    smallInd = smallInd + 1;
    
end

lengde = length(nodeSt.Node);
par = nodeSt.Parent(lengde);
shortPath(1) = nodeSt.Node(lengde); 
for i = 2:inf
   index = find(nodeSt.Node == par);   
   shortPath(i)= nodeSt.Node(index);
   par = nodeSt.Parent(index);
   if par ==0;
       break;
   end
end

% for i=1:length(nodeSt.Node)
%     naboer(nodeSt.Node(i)) = nodeSt.Parent(i);
% end
% 
% figure(4)
% treeplot(naboer)

      