clear all
       
% R(:,:,1)  = box(2,4,2); %funker
% Obs(:,:,1) = box(1,1,9);

R(:,:,1)  = box(2,5,2);
Obs(:,:,1) = box(2,2,9);

DH1 = [pi/7, 5, 4, pi/6];
T1 = dh(DH1);
RRot(:,:,1) = T1(1:3,1:3);
RTrans(:,1) = T1(1:3,4);

DH2 =[pi/4, -4, -6, pi/3];
T2 = dh(DH2);
ObsRot(:,:,1) = T2(1:3,1:3);
ObsTrans(:,1) = T2(1:3,4);
   
[rW rL rD] = size(R);
for k=1:rD
    for i=1:length(R(:,:,k))
        RTransformed(i,:,k) = RRot(:,:,k)*R(i,:,k)' + RTrans(:,k);
    end
end

[obsW obsL obsD] = size(Obs)
for k=1:obsD
    for i=1:length(Obs(:,:,k))
        ObsTransformed(i,:,k) = ObsRot*Obs(i,:,k)' + ObsTrans(:,k);
    end
end
   
[convM M ] = convMin(RTransformed(:,:,1),ObsTransformed(:,:,1));


            vInit = [ 2 -6 3]';   
 
                                       
                            
             %Extract the disatance, direction, closest point on R obstacle
             [inter dist v r obs ] = gjkLines(vInit, [2 5 2], RRot(:,:,1), RTrans(:,:,1), [2 2 9], ObsRot(:,:,1), ObsTrans(:,:,1) );
            
 figure(5) 
 hold on
 plot3([obs(1) r(1)], [obs(2) r(2)], [obs(3) r(3)]);
 figure(6)
 hold on
 plot3([v(1) 0], [v(2) 0], [v(3) 0],'g');


   
[ RX RY RZ] = boxf( R(:,:,1), RRot(:,:,1), RTrans(:,1) );
[ ObsX ObsY ObsZ] = boxf(Obs(:,:,1), ObsRot(:,:,1), ObsTrans(:,1) );
figure(5)
%plot3( R1Trans(:,1), R1trans(:,2), R1trans(:,3), 'o' );
%patch( R1Trans(:,1), R1trans(:,2), R1trans(:,3), [ 0 1 0] );
 patch(RX, RY, RZ, [0 1 0]);
 hold on
 patch(ObsX, ObsY, ObsZ, [1 0 0])
 axis([-10 10 -10 10 -10 10]);
 hold off;
 figure(6)
 hold off