
function [ffT] = linRob(x, y, z, theta)

DenHaf = [-pi/2       z+38    0   -pi/2
          -pi/2        x      0    pi/2
          -pi/2        y      0    pi/2
           theta(1)       6.15  1.00  -pi/2
           theta(2)-pi/2  0.00  7.05   0
           theta(3)       0.00  1.35  -pi/2
           theta(4)       7.55  0.00  pi/2]; 
%thetaFinal = [DenHaf(1,1) DenHaf(2,1) DenHaf(3,1) DenHaf(4,1) ]'

Manip = 0.5*[ 2.40 2.40 2.40
              2.10 40.0 2.10
              1.10 1.10 4.10
              5.10 6.15 5.10 
              7.05 2.00 2.00
              2.50 2.00 3.60
              1.50 9.35 1.50  ];
          
Man = 0.5*[ 0.00 2.40 0.00
            0.00 40.0 0.00
            0.00 0.00 4.10
            0.00 6.15 0.00
            7.05 0.00 0.00
            0.00 0.00 3.60
            0.00 9.35 0.00  ];         

  % Making transformation matrices for the final joint frames
[ffT, ffRot, ffTrans ] = dh(DenHaf);

% Making transformation matrices for the final links
[lfT, lfRot, lfTrans ] = dhLinkABBSystem(ffT,Manip,Man);

[linksN notInUse1] = size(Manip);
% [obsN notInUse2] = size(Obstacles);

figure(4)
plot3(ffT(1,4,3), ffT(2,4,3), ffT(3,4,3),'r o')
hold on

for k=1:linksN
    [xlink1 ylink1 zlink1] = linkTransf( Manip(k,1), Manip(k,2), Manip(k,3) , lfRot(:,:,k), lfTrans(:,:,k) );
    patch(xlink1, ylink1, zlink1, [1 0 0]);
end
% [xlink1f ylink1f zlink1f] = linkTransf( Manip(4,1), Manip(4,2), Manip(4,3) , lfRot(:,:,4), lfTrans(:,:,4) );
% [xlink2f ylink2f zlink2f] = linkTransf( Manip(5,1), Manip(5,2), Manip(5,3) , lfRot(:,:,5), lfTrans(:,:,5) ); % -  fRot(:,:,2)*[Manip(2,1) 0 0 ]' ) );
% [xlink3f ylink3f zlink3f] = linkTransf( Manip(6,1), Manip(6,2), Manip(6,3) , lfRot(:,:,6), lfTrans(:,:,6) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    
% [xlink4f ylink4f zlink4f] = linkTransf( Manip(7,1), Manip(7,2), Manip(7,3) , lfRot(:,:,7), lfTrans(:,:,7) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    
% 
% patch(xlink1f, ylink1f, zlink1f, [1 0 0]);
% patch(xlink2f, ylink2f, zlink2f, [1 0 0]);
% patch(xlink3f, ylink3f, zlink3f, [1 0 0]);
% patch(xlink4f, ylink4f, zlink4f, [1 0 0]);

axis([-20 20 -20 20 0 40]);
hold off