% Put robot configuations in to "boxes"

function [boxStruct] = makeBoxes(joint, Samples)

% joint = 8;

boxStruct(1,1,1) = struct('Nodes',[]) 

for i=1:length(Samples)
    linValues = Samples(2:4,i);
    theta = Samples(5:10,i);
    
    [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(linValues, theta);
    
    [xL yL zL] = size(boxStruct);
    
    j3 = ffT(1:3,4,joint);
    x = ceil(j3(1));
    y = ceil(j3(2));
    z = ceil(j3(3)); 
    
    if x<1
        x=1;
    end
     if y<1
        y=1;
     end
     if z<1
        z=1;
    end
    
    if x> xL
        inc = true;
    end
    if y> yL
        inc = true;
    end
    if z> zL
        inc = true;
    end
    
    if inc
        boxStruct(x,y,z) = struct('Nodes', i);
    else
        boxStruct(x,y,z).Nodes = [boxStruct(x,y,z).Nodes i]; 
    end
         
end