
function makePathVideo(postPath, figNumber, color, fileName)

fig=figure(figNumber);
set(fig,'DoubleBuffer','on');

set(gca,'xlim',[0 100],'ylim',[0 100],'zlim',[0 60],...
	   'NextPlot','replace','Visible','off') 
mov = avifile(fileName,'fps',5,'compression', 'Indeo5')

linksN = 10;

for i= 1:length(postPath)
    figure(figNumber)
    hold off
    plot3(50,50,0,'o')
    hold on
    
    [Obstacles oT oRot oTrans obsN] = makeAndDrawObstaclesVideo(figNumber);
    [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] =...
        makeRobot( postPath(2:4,i), postPath(5:10,i) ) ;%makeRobot(linValues, theta);
    drawRobotVideo(figNumber,color, linksN, Manip, lRot, lTrans)
    drawGantryCrane(figNumber,color, fT, postPath(2,i))
%     set(h,'EraseMode','xor');
set(gca,'xlim',[0 100],'ylim',[0 100],'zlim',[0 60]);
% set(gca,'xlim',[-100 100],'ylim',[-100 100],'zlim',[-100 100]);
	F = getframe(gca);
	mov = addframe(mov,F);
end
mov = close(mov);

% for k=1:length(x)
% 	h = patch(sin(x)*radius(k),cos(x)*radius(k),...
% 				[abs(cos(x(k))) 0 0]);
% 	set(h,'EraseMode','xor');
% 	F = getframe(gca);
% 	mov = addframe(mov,F);
% end
% mov = close(mov);

% linksN = 10;
% figure(fig)
% hold off
% plot3(0,0,0,'o')
% hold on
% [Obstacles oT oRot oTrans obsN] = makeAndDrawObstacles(fig);
% for i= 1:length(postPath)
%     [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] =...
%         makeRobot( postPath(2:4,i), postPath(5:10,i) ) ;%makeRobot(linValues, theta);
%     drawRobot(fig,color, linksN, Manip, lRot, lTrans)
% end