% Make samples

function [Samples comp] = makeSamples(JALimits, stepLength, Manip, Man, Obstacles, oRot, oTrans)

[linksN notInUse1] = size(Manip);
[obsN notInUse2] = size(Obstacles);

%%%%%%%% Starting the Probabilistic RoadMap method%%%%%%%              
%Config(1:8,1:4,4,1000) = zeros;
comp(1) = struct('Node',[1], 'NB',[0]);
emptyComp(1) = 2;

con = 1;
for Th1=JALimits(1,1):30/180*pi:JALimits(1,2)
    for Th2=JALimits(2,1)+pi/2:stepLength:JALimits(2,2)+pi/2
        for Th3=JALimits(3,1):stepLength:JALimits(3,2)
%             for Th4=JALimits(4,1):stepLength:JALimits(4,2)
                Th4 = 0;
                DH = [Th1       6.15  1.00  -pi/2
                      Th2-pi/2  0.00  7.05  0
                      Th3       0.00  1.35  -pi/2
                      Th4       7.55  0.00  pi/2];

                % Making transformation matrices for the joint frames
                [fT, fRot, fTrans ] = dh(DH);
                % Making transformation matrices for the links
                [lT, lRot, lTrans ] = dhLinkABB(fT,Manip,Man);

                % Checking for collision  between links and obstacles

                inter = collisionCheck(linksN, obsN, Manip, lRot, lTrans, Obstacles, oRot, oTrans);
%                                 
      %*********** if no collision detected in current configuration, store
                % the configuration
                if inter == false
                    
                    theta = [Th1 Th2 Th3 Th4]';
                    Samples(1:4,con) = theta;
                    Samples(5:6,con) = 0;                                       
                    %Config(1:4, 1:4,:,con) = fT;
                    %Config(5:8, 1:4,:,con) = lT;                    
                    
                    % plot the configuration
                    plot3( [fT(1,4,1) fT(1,4,2) fT(1,4,3) fT(1,4,4)],[fT(2,4,1) fT(2,4,2) fT(2,4,3) fT(2,4,4) ],[fT(3,4,1) fT(3,4,2) fT(3,4,3) fT(3,4,4)] )
                                                          
                    if con == 1                       
                        Samples(5,con)=1; %Sample 1 belongs to component 1                        
                    else
                        % Start try connect to a configuration
                        for c=1:length(comp)
                            if comp(c).Node>0 
                                % Find the closest configuration in the component
%                                 teller = 1;
                                clear TempMat;                                
                                for teller = 1:length(comp(c).Node) %Computing distance to all nodes in  one component
                                    TempMat(teller,:) = [configDist(theta, Samples(1:4, comp(c).Node(teller) ), [1 1 1 1'] ), comp(c).Node(teller) ];
                                end                                
                                
                                % Sort the matrix with increasing distance
                                clear sortMat;                                
                                sortMat = sortrows(TempMat);
                                % Try make a connection between current node
                                % and closest node                               
                                [rows col] = size(sortMat);
                                if rows>10
                                    rows = 10;
                                end
                                for ind=1:rows                                    
                                    interaction = binCollisionCheck( [theta Samples(1:4, sortMat(ind,2)) ],5*pi/180,linksN, obsN, Manip,Man, Obstacles, oRot, oTrans);
                                    if ~interaction % If no interaction, add the node to the component
                                        [ connectSuccess Samples comp emptyComp] = connectNode(con, c, ind, Samples, comp, sortMat, emptyComp);
                                        if connectSuccess % Node added to component break for loop
                                            break;
                                        end
                                    end
                                end % If no connection found in this component, try next component.
                            end 
                        end % Done trying all components
                        
                        % if component connection failed, make a new
                        % component
                        [Samples comp emptyComp] = connectToEmptyComponent(con,Samples, comp, emptyComp);                        
                    end                    
                    con = con + 1; 
                end
%             end %end theta4 loop 
        end %end theta3 loop 
    end %end theta2 loop 
end %end theta1 loop 
