% Make samples

function [Samples comp] = makeSamplesABB(LinLimits, JALimits, stepLength, Obstacles, oRot, oTrans)

% [Obstacles oT oRot oTrans obsN] = makeObstacles();

[obsN notInUse2] = size(Obstacles);

%%%%%%%% Starting the Probabilistic RoadMap method%%%%%%%              
%Config(1:8,1:4,4,1000) = zeros;
comp(1) = struct('Node',[1], 'NB',[0]);
emptyComp(1) = 2;

con = 1;
for pos =1:40
    linValues(1,1) = 0.5*abs(LinLimits(1,1))+abs(LinLimits(1,2))*rand() + LinLimits(1,1);
    linValues(2,1) = 0.5*abs(LinLimits(2,1))+abs(LinLimits(2,2))*rand() + LinLimits(2,1);
    linValues(3,1) = 0.5*abs(LinLimits(3,1))+abs(LinLimits(3,2))*rand() + LinLimits(3,1);
    for angle =1:2
        Th1 = (abs(JALimits(1,1))+abs(JALimits(1,2))*rand() + JALimits(1,1) ); 
        Th2 = (abs(JALimits(2,1))+abs(JALimits(2,2))*rand() + JALimits(2,1) ); 
        Th3 = (abs(JALimits(3,1))+abs(JALimits(3,2))*rand() + JALimits(3,1) ); 
% for Th1=JALimits(1,1):30/180*pi:JALimits(1,2)
%     for Th2=JALimits(2,1)+pi/2:stepLength:JALimits(2,2)+pi/2
%         for Th3=JALimits(3,1):stepLength:JALimits(3,2)
%             for Th4=JALimits(4,1):stepLength:JALimits(4,2)
             
        theta = [Th1 Th2 Th3 0 0 0]';
        [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] =...
            makeRobot(linValues, theta);                                
        [linksN notInUse1] = size(Manip);
                % Checking for collision  between links and obstacles

                inter = collisionCheckABB(linksN, obsN, Manip, lRot, lTrans, Obstacles, oRot, oTrans);
%                                 
      %*********** if no collision detected in current configuration, store
                % the configuration
                if inter == false
                    drawRobot(1,[1 0 0], linksN, Manip, lRot, lTrans)
                    drawGantryCrane(1, fT, linValues(1))
%                     theta = [Th1 Th2 Th3 Th4]';
                    Samples(1,con) = 0;
                    Samples(2:4,con) = linValues;
                    Samples(5:10,con)= theta;
                    Samples(11:12,con) = 0;                                       
                    %Config(1:4, 1:4,:,con) = fT;
                    %Config(5:8, 1:4,:,con) = lT;                    
                    
                    % plot the configuration
                    plot3( [fT(1,4,1) fT(1,4,2) fT(1,4,3) fT(1,4,4)],[fT(2,4,1) fT(2,4,2) fT(2,4,3) fT(2,4,4) ],[fT(3,4,1) fT(3,4,2) fT(3,4,3) fT(3,4,4)] )
                                                          
                    if con == 1                       
                        Samples(11,con)=1; %Sample 1 belongs to component 1                        
                    else
                        % Start try connect to a configuration
                        for c=1:length(comp)
                            if comp(c).Node>0 
                                % Find the closest configuration in the component
%                                 teller = 1;
                                clear TempMat;                                
                                for teller = 1:length(comp(c).Node) %Computing distance to all nodes in  one component
                                    TempMat(teller,:) = [configDist([ 0; linValues; theta], Samples(1:10, comp(c).Node(teller) ), [0 1 1 1 1 1 1 1 1 1] ), comp(c).Node(teller) ];
                                end                                
                                
                                % Sort the matrix with increasing distance
                                clear sortMat;                                
                                sortMat = sortrows(TempMat);
                                % Try make a connection between current node
                                % and closest node                               
                                [rows col] = size(sortMat);
                                if rows>10
                                    rows = 10;
                                end
                                for ind=1:rows     
                                    Config(1:10,1) = [0; linValues; theta ];
                                    Config(1:10,2) = Samples(1:10, sortMat(ind,2));
                                    interaction = binCollisionCheckABB( Config,1, 5*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                                    if ~interaction % If no interaction, add the node to the component
                                        [ connectSuccess Samples comp emptyComp] = connectNodeABB(con, c, ind, Samples, comp, sortMat, emptyComp);
                                        if connectSuccess % Node added to component break for loop
                                            break;
                                        end
                                    end
                                end % If no connection found in this component, try next component.
                            end 
                        end % Done trying all components
                        
                        % if component connection failed, make a new
                        % component
                        [Samples comp emptyComp] = connectToEmptyComponentABB(con,Samples, comp, emptyComp);                        
                    end                    
                    con = con + 1; 
                end
%             end %end theta4 loop 
%         end %end theta3 loop 
    end %end theta2 loop 
end %end theta1 loop 
% end %end the pos for loop
