% Manipulator visualization

figure(1)
hold off
plot3(0,0,0,'o');
hold on

Manip = [0.5 4 0.5
         3 0.5 0.5
         2 0.5 0.5 ]; 
Man  =[ 0 4 0
        3 0 0
        2 0 0 ];   

th1=   0;
th2=   pi/4;
th3=   pi/9;

DH = [th1      8 0 pi/2
      th2+pi/2 0 6 0
      th3      0 4 0 ];
  DH2 = [th1      8 0 pi/2
         th2+pi/2 0 6 0
         th3      0 4 0 ];
  
  % Making transformation matrices for the joint frames
[fT, fRot, fTrans ] = dh(DH);
  % Making transformation matrices for the links
[lT, lRot, lTrans ] = dhLink(fT,Man);

[Jtrans] = jacobianT01_old();
[Jtrans2] = jacobianT02_old(DH2);
[Jtrans3] = jacobianT03_old(DH2);

  
  % Making the links
  
[xlink1 ylink1 zlink1] = linkTransf( Manip(1,1), Manip(1,2), Manip(1,3) , lRot(:,:,1), lTrans(:,:,1) );
[xlink2 ylink2 zlink2] = linkTransf( Manip(2,1), Manip(2,2), Manip(2,3) , lRot(:,:,2), lTrans(:,:,2) ); % -  fRot(:,:,2)*[Manip(2,1) 0 0 ]' ) );
[xlink3 ylink3 zlink3] = linkTransf( Manip(3,1), Manip(3,2), Manip(3,3) , lRot(:,:,3), lTrans(:,:,3) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    

    % Making some obstacles
    
Obstacles = [1 1 1
             2 2 2
             1 5 1];
    
ObsMat= [pi/6 pi/3 pi/2   6   6   6
         pi/2  pi/9    pi/6    -4  -3   5
         pi/4 pi/4 pi/6 -10   6   6 ];
          
 
[oT oRot oTrans] = obsTransformation(ObsMat);

[xobs1 yobs1 zobs1] = obsTransf( Obstacles(1,1), Obstacles(1,2), Obstacles(1,3), oRot(:,:,1), oTrans(:,:,1) );      
[xobs2 yobs2 zobs2] = obsTransf( Obstacles(2,1), Obstacles(2,2), Obstacles(2,3), oRot(:,:,2), oTrans(:,:,2) );      
[xobs3 yobs3 zobs3] = obsTransf( Obstacles(3,1), Obstacles(3,2), Obstacles(3,3), oRot(:,:,3), oTrans(:,:,3) );      

    % Calculating closest distances between links and obstacles
    
    it = 0;
    for l=1:3
        
        for o =1:3
            it = it+1;
             %Starting the GJK algorithm
             %Initializing
            
             vInit = [ 2 -6 3]';   
             
             %Check for collision
             inter  = gjkInter(vInit, Manip(l,:), lRot(:,:,l), lTrans(:,:,l), Obstacles(o,:), oRot(:,:,o), oTrans(:,:,o) );   
             %Extract the disatance, direction, closest point on R obstacle
             [inter dist v r obs ] = gjk(vInit, Manip(l,:), lRot(:,:,l), lTrans(:,:,l), Obstacles(o,:), oRot(:,:,o), oTrans(:,:,o) );
             if inter
                 break;
             end
             distance(it) = dist;
             
             figure(1)
             hold on
             if l==1
                plot3([r(1) obs(1)],[r(2) obs(2)],[r(3) obs(3)],'- h b');
             elseif l==2
                plot3([r(1) obs(1)],[r(2) obs(2)],[r(3) obs(3)], '- h y');
             elseif l==3
                plot3([r(1) obs(1)],[r(2) obs(2)],[r(3) obs(3)], '- h m');   
             end
        end
        
        if inter
            break;
        end
    end
    
    
    % Drawing the output    

figure(1)
patch(xlink1, ylink1, zlink1, [1 0 0]);
hold on
patch(xlink2, ylink2, zlink2, [1 0 0]);
patch(xlink3, ylink3, zlink3, [1 0 0]);

patch(xobs1,  yobs1,  zobs1,  [0 1 0]);
patch(xobs2,  yobs2,  zobs2,  [0 1 0]);
patch(xobs3,  yobs3,  zobs3,  [0 1 0]);

for i=1:3
    plot3(fTrans(1,1,i), fTrans(2,1,i), fTrans(3,1,i), 'b o' )
end

axis([-20 20 -20 20 0 20]);
hold off

