% 3D Path Planning and visualization
clear all;
figure(1)
hold off
plot3(0,0,0,'o')
hold on

%% Initalzing
zeta = [0 0.1 0.1 0.1 1 0.5 0.5 2 0.2 0.2];     % Uatt potential field factor
obsLimit = 10;            % Limit for Urep potential field
goalLimit = 2;            % Limit for conic potential field
eta = 10;                  % Urep potential field factor
w = [1 1 1 1]';           % Distance weight  
alpha =0.1;               % step length in descent algorithm
beta = 0.5;                 % step length in descent algorithm  

epsiLin = 12*[ 0.1 0.1 0.1]';
epsiTheta = 5*[0.1 0.1 0.1 0.1 0.1 0.1];
mainRuns = 60;

%% Making some obstacles 

[Obstacles oT oRot oTrans obsN] = makeObstacles();

%% Making the the robot

linksN=10;

% Makes the robot in final position
finalPos = [-5 -3 -4]';
thetaFinal = [pi/3 -pi/5 -pi/7 pi/4 pi/4 pi/6];

[Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
   
% Makes the  robot in its initial position  
    %%%%%% Initial pose %%%%%%%
linValues = [5 -2 -0.5]';     
thetaStart = [pi/3 pi/6 -pi/6 pi/8 -pi/4 pi/6]';

[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);
theta = [DH(5,1) DH(6,1) DH(7,1) DH(8,1) DH(9,1) DH(10,1)]';
%%%%%%% Starting the for loop to compute the path %%%%%%
%% Starting the for loop

for i=1:mainRuns% 95 funker fint
    
        if abs(linValues(1)-finalPos(1))< epsiLin(1) && ... 
           abs(linValues(2)-finalPos(2))< epsiLin(2) && ...
           abs(linValues(3)-finalPos(3))< epsiLin(3) && ...
           abs(theta(1)-DenHaf(5,1))< epsiTheta(1) && ...
           abs(theta(2)-DenHaf(6,1))< epsiTheta(2) && ...
           abs(theta(3)-DenHaf(7,1))< epsiTheta(3) && ...
           abs(theta(4)-DenHaf(8,1))< epsiTheta(4)  
%            abs(theta(5)-DenHaf(9,1))< epsiTheta(5) && ...
%            abs(theta(6)-DenHaf(10,1))< epsiTheta(6) 
       disp('Done!')
            break;
        end
%     hallo = hallo + 1;
    % Making transformation matrices for the joint frames
    [fT, fRot, fTrans ] = dh(DH);
    % Making transformation matrices for the links
    [lT, lRot, lTrans ] = dhLinkABBSystem(fT,Manip,Man);  
    
    drawRobot(1,[0 1 0], linksN, Manip, lRot, lTrans)

%% Calculate the transposed Jacobian of "fixed" length

    fJacobianABBT(:,:,5) = jacABBT01(fT);  
    fJacobianABBT(:,:,6) = jacABBT02(fT);  
    fJacobianABBT(:,:,7) = jacABBT03(fT);
    fJacobianABBT(:,:,8) = jacABBT04(fT);
    fJacobianABBT(:,:,9) = jacABBT05(fT);
    fJacobianABBT(:,:,10) = jacABBT06(fT);
    
%% Calculating the Attractive field (only for end effector?)
    attTorque(1:linksN-4,1) =zeros;
    for k=4:linksN %Starting in the frame attached to the vertical bar 
        
        dist = norm ( ffT(1:3,4,k)-fT(1:3,4,k) );
        
        if dist < goalLimit
            Uatt(:,k) = 0.5*zeta(k)*(dist^2);       % ( not really in use )
            pa(:,k)  = -zeta(k)*( fT(1:3,4,k) - ffT(1:3,4,k) );
        else
            %Uatt(:,k)=goalLimit*0.5*zeta(k)*dist - 0.5*zeta*(goalLimit^2);
            Uatt(:,k) =  goalLimit*0.5*zeta(k)*dist; % (not really in use)
            pa(:,k)   = -goalLimit*0.5*zeta(k)*( fT(1:3,4,k) - ffT(1:3,4,k) )/dist; 
        end
        if k>4 % calculating torque only for the revloute joints    
            attTorque = attTorque + fJacobianABBT(:,:,k)*pa(:,k);
        end
    end    
   attForce = pa(:,4); % pa(:,2)+pa(:,3)+pa(:,4)
%% Calculating closest distances between links and obstacles 
 
    it = 0;
    repTorque(1:linksN-4,1) = zeros;
    repulsiveForce = [0 0 0]';
    for l=4:linksN %Starting in the frame attached to the vertical bar       
        for o =1:obsN
            it = it+1;
             %Starting the GJK algorithm
             %Initializing
            
              % Finding an initial vector inside A-B using the Supportpoints             
             avec = [ 2 6 3]';
             wR   = supportPoint(-avec,  Manip(l,:), lRot(:,:,l), lTrans(:,:,l));   
             wObs = supportPointCyl(avec, Obstacles(o,1), Obstacles(o,2), oRot(:,:,o), oTrans(:,:,o));  
             
             a = wR-wObs; 
             
             bvec = [ 2 -6 3]';
             wR   = supportPoint(-bvec,  Manip(l,:), lRot(:,:,l), lTrans(:,:,l));   
             wObs = supportPointCyl(bvec, Obstacles(o,1), Obstacles(o,2), oRot(:,:,o), oTrans(:,:,o));  
             b = wR-wObs;             
             
             c = a-b;
             vInit = b + 0.5*c;       

             %Extract the disatance, direction, closest point on R obstacle
             [inter dist v r obs ] = gjkBoxCyl(vInit, Manip(l,:), lRot(:,:,l), lTrans(:,:,l), Obstacles(o,1), Obstacles(o,2), oRot(:,:,o), oTrans(:,:,o) );
             
              if inter==1   
                 plot3([r(1) obs(1)], [r(2) obs(2)], [r(3) obs(3)],'r');
                 plot3(r(1),r(2),r(3),'h k');
                 plot3(obs(1),obs(2),obs(3),'h k');
                 disp(' **************INTERSECTION***************************************************************************************')
                 break;
             end
             
             if dist<0.001
                 dist
                 error(' possible intersection')
                
             end              
             
             %%%%%%%% Calculate the "variable" transposed Jacobian %%%%%  
             if l ==5                           
                 JacobianABBTVar(:,:,5) = jacABBT01Var(fT,r);                
             elseif l==6                  
                 JacobianABBTVar(:,:,6) = jacABBT02Var(fT,r);
             elseif l==7    
                 JacobianABBTVar(:,:,7) = [0 0 0 
                                           0 0 0 
                                           0 0 0 
                                           0 0 0
                                           0 0 0
                                           0 0 0];
             elseif l==8
                 JacobianABBTVar(:,:,8) = jacABBT04Var(fT,r);
             elseif l==9
%                 JacobianABBTVar(:,:,9) = jacABBT05Var(fT,r);
                 JacobianABBTVar(:,:,9) = [0 0 0 
                                           0 0 0 
                                           0 0 0 
                                           0 0 0
                                           0 0 0
                                           0 0 0];
             elseif l==10
                 JacobianABBTVar(:,:,10) = jacABBT06Var(fT,r);
                 
               
             end
             
             %%%%%%% Calculate the Repulisve field %%%%%%
             if dist < obsLimit
                 Ur = 0.5*eta*(( 1/dist - 1/obsLimit )^2);                 
                 repForce = -eta*( 1/obsLimit - 1/dist ) * ( 1/(dist^2) ) * ((r-obs )/dist); % * (( Y(i,j)-obst(2) )/Dist(i,j));
                 if l>4
                    repTorque = repTorque + JacobianABBTVar(:,:,l)* repForce';                         
                 else
                    repulsiveForce = repulsiveForce + repForce' ;
                 end
             end             
        end 
             if inter==1                 
                 disp(' **************INTERSECTION***************')
                 break;
             end             
    end
    if inter==1                 
        disp(' **************INTERSECTION***************')
        break;
    end
%% Summarize attractive and repulsive torques
     
    sumTorque = attTorque + repTorque;
    sumLinForces = attForce + repulsiveForce;
    
     % Check if torque exceeds torque limit
%     for k=1:linksN       
%         if sumTorque(k)>torqueLimit(k)
%             sumTorque(k) = torqueLimit(k)
%         elseif -sumTorque(k)>torqueLimit(k)
%             sumTorque(k) = -torqueLimit(k)
%         end
%     end     
%%  Updating the new theta values

    linValues = linValues + beta*sumLinForces/norm(sumLinForces);
    
    theta = theta + alpha*sumTorque/norm(sumTorque);
    
    [linValues, theta]=limitCheck(linValues, theta, LinLimits, JALimits);
%     if linValues(1) < LinLimits(1,1)
%         linValues(1)= LinLimits(1,1);
%     elseif linValues(1) > LinLimits(1,2)
%         linValues(1)= LinLimits(1,2);
%     elseif linValues(2) > LinLimits(2,2)
%         linValues(2)= LinLimits(2,2);
%     elseif linValues(2) < LinLimits(2,1)
%         linValues(2)= LinLimits(2,1);
%     elseif linValues(3) > LinLimits(3,2)
%         linValues(3)= LinLimits(3,2)
%     elseif linValues(3) < LinLimits(3,1)
%         linValues(3)= LinLimits(3,1)
%     elseif theta(1) < JALimits(1,1)
%         theta(1) =    JALimits(1,1);
%     elseif theta(1) > JALimits(1,2)
%         theta(1) =    JALimits(1,2);
%     elseif theta(2) < JALimits(2,1)
%         theta(2) =    JALimits(2,1);
%     elseif theta(2) > JALimits(2,2)
%         theta(2) =    JALimits(2,2);
%     elseif theta(3) < JALimits(3,1)
%         theta(3) =    JALimits(3,1);   
%     elseif theta(3) > JALimits(3,2)
%         theta(3) =    JALimits(3,2);
%     elseif theta(4) < JALimits(4,1)
%         theta(4) =    JALimits(4,1);
%     elseif theta(4) > JALimits(4,2)
%         theta(2) =    JALimits(4,2);
%     end
    
%     %     %Collecting waypoints
%     if hallo == 25
%         WP(:,indi) = theta;
%        indi = indi+1;
%         hallo = 0;
%     end
    DH(2,2)  = linValues(2); % x
    DH(3,2)  = linValues(1); % y
    DH(4,2)  = linValues(3); % z
    DH(5,1)  = theta(1);
    DH(6,1)  = theta(2);
    DH(7,1)  = theta(3);
    DH(8,1)  = theta(4);
    DH(9,1)  = theta(5);
    DH(10,1) = theta(6);
    
%     plot3( [fT(1,4,1) fT(1,4,2) fT(1,4,3) fT(1,4,4)],[fT(2,4,1) fT(2,4,2) fT(2,4,3) fT(2,4,4) ],[fT(3,4,1) fT(3,4,2) fT(3,4,3) fT(3,4,4)] )
    
%         % Making the link objects in current pose for visualization
%   
% [xlink1 ylink1 zlink1] = linkTransf( Manip(1,1), Manip(1,2), Manip(1,3) , lRot(:,:,1), lTrans(:,:,1) );
% [xlink2 ylink2 zlink2] = linkTransf( Manip(2,1), Manip(2,2), Manip(2,3) , lRot(:,:,2), lTrans(:,:,2) ); % -  fRot(:,:,2)*[Manip(2,1) 0 0 ]' ) );
% [xlink3 ylink3 zlink3] = linkTransf( Manip(3,1), Manip(3,2), Manip(3,3) , lRot(:,:,3), lTrans(:,:,3) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    
% [xlink4 ylink4 zlink4] = linkTransf( Manip(4,1), Manip(4,2), Manip(4,3) , lRot(:,:,4), lTrans(:,:,4) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    
% 
% % Drawing the manipulator in its current pose
% patch(xlink1, ylink1, zlink1, [0 0 1]);
% patch(xlink2, ylink2, zlink2, [0 0 1]);
% patch(xlink3, ylink3, zlink3, [0 0 1]);
% patch(xlink4, ylink4, zlink4, [0 0 1]);
    
end    
    
    
    
%% Drawing the output

    % Making the link objects in final pose for visualization
% 
% [xlink1f ylink1f zlink1f] = linkTransf( Manip(1,1), Manip(1,2), Manip(1,3) , lfRot(:,:,1), lfTrans(:,:,1) );
% [xlink2f ylink2f zlink2f] = linkTransf( Manip(2,1), Manip(2,2), Manip(2,3) , lfRot(:,:,2), lfTrans(:,:,2) ); % -  fRot(:,:,2)*[Manip(2,1) 0 0 ]' ) );
% [xlink3f ylink3f zlink3f] = linkTransf( Manip(3,1), Manip(3,2), Manip(3,3) , lfRot(:,:,3), lfTrans(:,:,3) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    
% [xlink4f ylink4f zlink4f] = linkTransf( Manip(4,1), Manip(4,2), Manip(4,3) , lfRot(:,:,4), lfTrans(:,:,4) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    
%     
%      % Making the link objects for visualization
%   
% [xlink1 ylink1 zlink1] = linkTransf( Manip(1,1), Manip(1,2), Manip(1,3) , lRot(:,:,1), lTrans(:,:,1) );
% [xlink2 ylink2 zlink2] = linkTransf( Manip(2,1), Manip(2,2), Manip(2,3) , lRot(:,:,2), lTrans(:,:,2) ); % -  fRot(:,:,2)*[Manip(2,1) 0 0 ]' ) );
% [xlink3 ylink3 zlink3] = linkTransf( Manip(3,1), Manip(3,2), Manip(3,3) , lRot(:,:,3), lTrans(:,:,3) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    
% [xlink4 ylink4 zlink4] = linkTransf( Manip(4,1), Manip(4,2), Manip(4,3) , lRot(:,:,4), lTrans(:,:,4) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    


% figure(1)
% 
% % Drawing the manipulator in its initial pose
% patch(xlink1i, ylink1i, zlink1i, [0 1 0]);
% patch(xlink2i, ylink2i, zlink2i, [0 1 0]);
% patch(xlink3i, ylink3i, zlink3i, [0 1 0]);
% patch(xlink4i, ylink4i, zlink4i, [0 1 0]);
% 
%  % Drawing the maipulttor in its final pose
% patch(xlink1f, ylink1f, zlink1f, [1 0 0]);
% patch(xlink2f, ylink2f, zlink2f, [1 0 0]);
% patch(xlink3f, ylink3f, zlink3f, [1 0 0]);
% patch(xlink4f, ylink4f, zlink4f, [1 0 0]);
% 
%  % Drawing the manipulator in its current pose
% patch(xlink1, ylink1, zlink1, [0 0 1]);
% patch(xlink2, ylink2, zlink2, [0 0 1]);
% patch(xlink3, ylink3, zlink3, [0 0 1]);
% patch(xlink4, ylink4, zlink4, [0 0 1]);

   

axis([-20 20 -20 20 0 40]);
% legend('green initial position')
hold off

