% New PRM planner

function [testConfigCovered, TestQueryConnection, ConnectionTime, PathSearchTime, testWidth ] = PRM_SamplingAnalysis_new(Components, Samples, weigthVec)

% clear PathSearchTime
% clear ConnectionTime
% testConfigCovered(1,1:6) = zeros;
% TestQueryConnection (1,1) = 0;
figure(2)
hold off
plot3(0,0,0,'o')
hold on

linksN = 10;

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(2);

% Define som test configurations
TestConfigs(:,1) = [0 38 14 0 -pi/2 60*pi/180 -pi/4 0 0 0]';
TestConfigs(:,2) = [0 47 15 -8 -pi/2 pi/5 -pi/4-pi/4 0 0 0]';
% TestConfigs(:,3) = [0 27 32 -8 0 pi/5 -pi/4 0 0 0]';
TestConfigs(:,3) = [0 52 28 -8 pi/2 20*pi/180 -pi/4 0 0 0]';
% TestConfigs(:,4) = [0 40 42 -8 pi/2 pi/5 -pi/4 0 0 0]';
TestConfigs(:,4) = [0 40 22 -8 -pi/2 20*pi/180 -pi/4 0 0 0]';
TestConfigs(:,5) = [0 59 38 -4 3*pi/4 -pi/20 -pi/20-pi/4 0 0 0]';
TestConfigs(:,6) = [0 51 25 -2 -pi/2 0 -pi/4 0 0 0]';
TestConfigs(:,7) = [0 51 28 -4 9*pi/20 pi/20 pi/8-pi/4 0 0 0]';
TestConfigs(:,8) = [0 63 25 -8 pi pi/5 -pi/4-pi/4 0 0 0]';

[testLen testWidth] = size(TestConfigs);
testConfigCovered(1,1:testWidth) = zeros;
TestQueryConnection(testWidth, testWidth) = 0;
PathSearchTime(testWidth, testWidth) = 0;
ConnectionTime(testWidth, testWidth) = 0;

for j=1:testWidth-1
    % Start Config
    startCon   = TestConfigs(:,j);
    linValues  = TestConfigs(2:4,j); 
    thetaStart = TestConfigs(5:10,j); 
    [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);
%     drawRobot(2,[0 1 0], linksN, Manip, lRot, lTrans);
    
    for k=(j+1):testWidth
        if j~=k 
            
            
            % Goal Config
            goalCon    = TestConfigs(:,k);
            finalPos   = TestConfigs(2:4,k); 
            thetaFinal = TestConfigs(5:10,k); 
            [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
%             drawRobot(2,[0 0 1], linksN, Manip, lfRot, lfTrans);
            
            
            %%%%% Need some kind of timer here %%%%%%%%
            tic
            [startNode, goalNode, newSamples, theComp, successArray]= connectStartGoal(startCon, goalCon, Samples, Components, weigthVec, Obstacles, linksN, obsN, oRot, oTrans);
            ConnectionTime(j,k) = toc;
            if successArray(1)
                testConfigCovered(j) = 1;
            end
            
            if k==testWidth && successArray(2)
                testConfigCovered(testWidth) = 1;
            end
            % [startNode, goalNode, newSamples, theComp]= connectStartGoalPoint(startCon, goalPoint, Samples, Components, Obstacles, linksN, obsN, oRot, oTrans,2);
            
            %%%%% Need some kind of timer here %%%%%%%%
            if successArray(3)
                
                TestQueryConnection (j,k) = 1;
                tic
                shortPath =  getShortestPath(startNode, goalNode ,theComp.Node, theComp.NB);
                PathSearchTime(j,k) = toc;

                
                % Draw the manipulator path
%                 for i=1:length(shortPath)-1
% 
%                     Config(1:10,1) = newSamples(1:10, shortPath(i) );
%                     Config(1:10,2) = newSamples(1:10, shortPath(i+1) );
%                     binDrawRobotABB(2, Config,1, 60*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
%                 end
            end

        end % End if 
    end % End k for loop
end % End j for loop




