% Kristoffer Aasland
% My first try making a path planner using a potential field 
clear all;
zeta = 1;       % Uatt potential field factor
h=0.1;          % Potential field Resolution
obsLimit = 4;   % Limit for Urep potential field
goalLimit = 3;  % Limit for conic potential field, not in use
eta = 1;        % Urep potential field factor

epsi = h*2;     %limit to goal in descent algorithm
alpha =0.1;     %step length in descent algorithm

start  = [1 8.8];
goal   = [9 1];
squareX = [4 5 6 6 6 5 4 4];
squareY = [4 4 4 5 6 6 6 5];
squarePlotX = [4 5 6 6 6 5 4 4 4];
squarePlotY = [4 4 4 5 6 6 6 5 4];

% Gradient Descent Algorithm

int = 2;
point = start;
tempVec = [0 0];
pathX(1) = point(1);
pathY(1) = point(2);

while sqrt((point(1)-goal(1))^2 + (point(2)-goal(2))^2) >= epsi

    % Calcuatling the attractive field Uatt:
    
    Uatt = 0.5*zeta*( (goal(1)-point(1)).^2 + (goal(2)-point(2)).^2 );
    pxa = zeta*(point(1)-goal(1));
    pya = zeta*(point(2)-goal(2));
    
    % Calculating the repulsive field Urep:
    
    Urep = 0;
    Ur = 0;
    pyrTemp = 0;
    pxrTemp = 0;
    pyr = 0;
    pxr = 0;

    for i=1:(length(squareX))
    
    obst = [squareX(i);   squareY(i) ];   
    Dist = sqrt( (obst(1)-point(1)).^2 + (obst(2)-point(2)).^2 );
   
          if Dist < obsLimit %&& abs(Dist(i,j))>0.1
                
                if Dist< 0.5 && Dist>=0
                    Dist = 0.132;
                elseif Dist> -0.5 && Dist<=0
                    Dist = -0.132;                
                end
                  
                Ur = 0.5*eta*(( 1/Dist - 1/obsLimit )^2);
                pxrTemp = 10 * eta*( 1/obsLimit - 1/Dist ) * ( 1/(Dist^2) ) * (( point(1)-obst(1) )/Dist); % * (( X(i,j)-obst(1) )/Dist(i,j));
                pyrTemp = 10 * eta*( 1/obsLimit - 1/Dist ) * ( 1/(Dist^2) ) * (( point(2)-obst(2) )/Dist); %* (( Y(i,j)-obst(2) )/Dist(i,j)); 
                 
                if Ur > 9999
                    Ur = 50;
                end
                
            else
                Ur= 0;
                pxrTemp = 0;
                pyrTemp = 0;
          end
   
        Urep = Urep + Ur;
        Ur = 0;
        pxr = pxr + pxrTemp;
        pyr = pyr + pyrTemp;
        pxrTemp = 0;
        pyrTemp = 0;
  
    end

    
    %Summing Repulsive and Attractive fields:
    Utot = Uatt + Urep;
    px = -pxa - pxr;
    py = -pya - pyr;
    
    mapPoint = [round(point(1)/h) round(point(2)/h) ];
    
    gradVec = [px py];
    if gradVec == [0 0]
        newDir = gradVec;
    else
        newDir = alpha*(gradVec)/norm(gradVec); 
    end

    
    point = point + newDir;
    pathX(int) = point(1);
    pathY(int) = point(2);
    int = int + 1;

end



% PLOT
figure(1)
plot(start(1),start(2),'x');
axis([0 10 0 10]) ;
hold on
plot(goal(1),goal(2),'x');

plot(pathX, pathY);
plot(squarePlotX,squarePlotY)

hold off



