% 3D Path Planning and visualization
% clear all;
% figure(1)
% hold off
% plot3(0,0,0,'o')
% hold on

% function [success linValues theta] = connectToPointPlanner(goalPoint, linValues, thetaStart,Obstacles, oRot, oTrans, obsN,fig)
function [success pointPath ] = potPointPlanner(startPoint, goalPoint,fig)
success = false;

%% Initalizing
zeta = [2 0 0 0 0 0 0 0 2 2];     % Uatt potential field factor
obsLimit = 3;            % Limit for Urep potential field
goalLimit = 4;            % Limit for conic potential field
eta = 10;                  % Urep potential field factor
etaClose = 0.1;
% w = [1 1 1 1]';           % Distance weight  
% alpha =0.1;               % step length in descent algorithm
beta = 0.5;                 % step length in descent algorithm  

epsi = 1;
epsiClose = 2;

mainRuns = 200 ;%60;
figure(fig)
% hold off
plot3(startPoint(1), startPoint(2), startPoint(3), 'g o')
% plot3([goalPoint2(1) goalPoint(1)], [ goalPoint2(2) goalPoint(2)], [goalPoint2(3) goalPoint(3)], 'r')
hold on
plot3(goalPoint(1), goalPoint(2), goalPoint(3), 'r o')

%% Making some obstacles 

[Obstacles oT oRot oTrans obsN] = makeAndDrawObstacles(fig);

%% Making the the robot

linksN=1;

% [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);
% [Manip, fT, lT, lRot, lTrans] = makeCubeRobot(startPoint);

%%%%%%% Starting the for loop to compute the path %%%%%%
%% Starting the for loop

for i=1:mainRuns% 95 funker fint

        if norm(startPoint - goalPoint ) < epsi 
            disp('Done!')
            success = true;
            return;
        end
%     hallo = hallo + 1;
    % Making transformation matrices for the joint frames
%     [fT, fRot, fTrans ] = dh(DH);
    % Making transformation matrices for the links
%     [lT, lRot, lTrans ] = dhLinkABBSystem(fT,Manip,Man);  
    [Manip, fT, lT, lRot, lTrans] = makeCubeRobot(startPoint);
    drawCube(fig,[0 1 0], linksN, Manip, lRot, lTrans)

    
%% Calculating the Attractive field
%     attTorque(1:linksN-4,1) =zeros;
    for k=1:1; % Calculates only the attractive force for the end effector 
        
        dist = norm ( goalPoint-fT(1:3,4,k) );
        
        if dist < goalLimit
            Uatt(:,k) = 0.5*zeta(k)*(dist^2);       % ( not really in use )
            pa(:,k)  = -zeta(k)*( fT(1:3,4,k) - goalPoint );
        else
            %Uatt(:,k)=goalLimit*0.5*zeta(k)*dist - 0.5*zeta*(goalLimit^2);
            Uatt(:,k) =  goalLimit*0.5*zeta(k)*dist; % (not really in use)
            pa(:,k)   = -goalLimit*0.5*zeta(k)*( fT(1:3,4,k) - goalPoint )/dist;
        end
        % calculating torque    
%             attTorque = attTorque + fJacobianABBT(:,:,k)*pa(:,k);
    end
        
   attForce = pa(:,k); % ***********hm e dette rett? pa(:,2)+pa(:,3)+pa(:,4)
%% Calculating closest distances between links and obstacles 
 
    it = 0;
%     repTorque(1:linksN-4,1) = zeros;
    repulsiveForce = [0 0 0]';
    for l=1:linksN %Starting in the frame attached to the vertical bar       
        for o =1:obsN
            it = it+1;
             %Starting the GJK algorithm
             %Initializing
            
              % Finding an initial vector inside A-B using the Supportpoints             
             avec = [ 2 6 3]';
             wR   = supportPoint(-avec,  Manip(l,:), lRot(:,:,l), lTrans(:,:,l));   
             wObs = supportPointCyl(avec, Obstacles(o,1), Obstacles(o,2), oRot(:,:,o), oTrans(:,:,o));  
             
             a = wR-wObs; 
             
             bvec = [ 2 -6 3]';
             wR   = supportPoint(-bvec,  Manip(l,:), lRot(:,:,l), lTrans(:,:,l));   
             wObs = supportPointCyl(bvec, Obstacles(o,1), Obstacles(o,2), oRot(:,:,o), oTrans(:,:,o));  
             b = wR-wObs;             
             
             c = a-b;
             vInit = b + 0.5*c;       

             %Extract the disatance, direction, closest point on R obstacle
             [inter dist v r obs ] = gjkBoxCyl(vInit, Manip(l,:), lRot(:,:,l), lTrans(:,:,l), Obstacles(o,1), Obstacles(o,2), oRot(:,:,o), oTrans(:,:,o) );
             
              if inter==1   
%                  plot3([r(1) obs(1)], [r(2) obs(2)], [r(3) obs(3)],'r');
%                  plot3(r(1),r(2),r(3),'h k');
%                  plot3(obs(1),obs(2),obs(3),'h k');
                 disp(' **************INTERSECTION***************************************************************************************')
                 break;
             end
             
             if dist<0.001
                 inter =true;
                 break;
%                  dist
%                  error(' possible intersection')
                
             end             
                                      
             %%%%%%% Calculate the Repulisve field %%%%%%
             if dist < obsLimit
%                  Ur = 0.5*eta*(( 1/dist - 1/obsLimit )^2);     
                if norm(startPoint - goalPoint ) < epsiClose 
                    repForce = -etaClose*( 1/obsLimit - 1/dist ) * ( 1/(dist^2) ) * ((startPoint-obs' )/dist); % * (( Y(i,j)-obst(2) )/Dist(i,j));
                else
                    repForce = -eta*( 1/obsLimit - 1/dist ) * ( 1/(dist^2) ) * ((startPoint-obs' )/dist); % * (( Y(i,j)-obst(2) )/Dist(i,j));
                end
%                  if l>4
% %                     repTorque = repTorque + JacobianABBTVar(:,:,l)* repForce';                         
%                  else
                    repulsiveForce = repulsiveForce + repForce ;
%                  end
             end             
        end 
             if inter==1                 
%                  disp(' **************INTERSECTION***************')
                 break;
             end             
    end
    if inter==1                 
        disp(' **************INTERSECTION***************')
        break;
    end
%% Summarize attractive and repulsive torques
    
    sumLinForces = attForce + repulsiveForce;
%     sumTorque = attTorque + repTorque;
    
 

%%  Updating the new theta values

    startPoint = startPoint + beta*sumLinForces/norm(sumLinForces);
    
    pointPath(:,i) = startPoint;
        
end    
    
    
  

