% Kristoffer Aasland
% My first try making a path planner using a potential field 
clear all;
zeta = 1;        % Uatt potential field factor
h= 0.9;          % Potential field Resolution
obsLimit = 4;    % Limit for Urep potential field
goalLimit = 4;   % Limit for conic potential field, not in use
eta = 3;         % Urep potential field factor

epsi = h;        %limit to goal in descent algorithm
alpha =0.17;     %step length in descent algorithm


start  = [1 9];
goal   = [9 1];
squareX = [4 5 6 4 5 6 4 5 6 ]; 
squareY = [4 4 4 5 5 5 6 6 6 ];  

% Potential filed

% Calcuatling the attractive field Uatt:
v = 0:h:10;
[X,Y] = meshgrid(v);
UattParabolic = 0.5*zeta*( (goal(1)-X).^2 + (goal(2)-Y).^2 );
UattConic = goalLimit*0.5*zeta*( sqrt((goal(1)-X).^2 + (goal(2)-Y).^2 )); % - 0.5*zeta*(goalLimit^2);
%[px,py] = gradient(-Uatt,h,h);

%-------with conic and parabolic field--------

DistAtt =  sqrt( (goal(1)-X).^2 + (goal(2)-Y).^2 );
Uatt = DistAtt*0;

    boundary = size(DistAtt);
    for i=1:boundary(1)
        for j=1:boundary(2)
            if DistAtt(i,j) > goalLimit
                Uatt(i,j) = UattConic(i,j);
            else
                Uatt(i,j) = UattParabolic(i,j);        
            end
        end          
    end
    

% Calculating the repulsive field Urep:

Urep = Uatt*0;
Ur = Uatt*0;
for i=1:(length(squareX))
    
    if i == length(squareX)
        obst = [6 6];
    else
        obst = [squareX(i);   squareY(i) ];
    end
Dist = sqrt( (obst(1)-X).^2 + (obst(2)-Y).^2 );
    sizen = size(Dist);      
    for i=1:sizen(1)
        for j=1:sizen(2)
            if Dist(i,j) < obsLimit
                Ur(i,j) = 0.5*eta*(( 1/Dist(i,j) - 1/obsLimit )^2);
                if Ur(i,j) > 9999
                    Ur(i,j) = 50;
                end
                
            else
                Ur(i,j)= 0;
            end
        end
    end
    Urep = Urep + Ur;
    Ur = Ur*0;
  
end


Utot =  Urep + Uatt; % Uatt; % Uatt; %
[pxr, pyr] = gradient(-Utot,h,h);

% Gradient Descent Algorithm

int = 2;
point = start;
tempVec = [0 0];
pathX(1) = point(1);
pathY(1) = point(2);

%while sqrt((point(1)-goal(1))^2 + (point(2)-goal(2))^2) >= epsi
for hei=1:100
    
    mapPoint = [round(point(1)/h) round(point(2)/h) ];
    pathZ(int-1) = Utot(mapPoint(2), mapPoint(1));
    gradVec = [pxr(mapPoint(2),mapPoint(1)) pyr(mapPoint(2),mapPoint(1))];
    if gradVec == [0 0]
        newDir = gradVec;
    else
        newDir = alpha*(gradVec); % /norm(gradVec) 
    end

    
    point = point + newDir;
    pathX(int) = point(1);
    pathY(int) = point(2);
    int = int + 1;
    %hei = hei + 1;
end
pathZ(int-1) = Utot(mapPoint(2), mapPoint(1));

% PLOT

figure(1)
plot(start(1),start(2),'x');
%axis([0 10 0 10]) ;
hold on
plot(goal(1),goal(2),'x');
%plot(pathX, pathY);
%plot(pathX, pathY);
%plot(squareX,squareY)
plot([4 6 6 4 4],[4 4 6 6 4])
contour(v,v,Utot);
quiver(v,v, pxr, pyr);

hold off

figure(2)

mesh(X,Y,Utot)
hold on

%plot3(pathX, pathY,pathZ','r' );
hold off



