%Script that shows a binary collision test

function [initialPos, thetaStart, finalPos, thetaFinal] = showConfig()

% Note joint variable number 1 is always equal to 0. This is implemented
% as a dummy variable because first row in DH-table is static.
% Config(1:10,1) = [0 5 3 -2 pi/4 pi/6 pi/8 pi/3 0 0]';     %Start configuration
% Config(1:10,2) = [0 5 30 -8 -pi pi/6 -pi/8 pi/3 0 0]'; %Goal configuration
% 
% Config(1:10,1) = [0 20 20 -2 pi/4 pi/6 pi/8 pi/3 0 0]';     %Start configuration
% Config(1:10,2) = [0 20 30 -6 pi/4 pi/6 pi/8 pi/3 0 0]'; %Goal configuration
figure(1)
hold off 
plot3(0,0,0, 'o')
hold on

maxStep = 10;
maxAngle = 45*pi/180;
linksN = 10;

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(1);

% Run the binary collision check
% [inter] = binCollisionCheckABB_New(Config,maxStep,maxAngle, linksN, obsN, Obstacles, oRot, oTrans)

% Config(1:10,1) = [0 17 32 -8 0 pi/5 -pi/4-pi/4 0 0 0]';     %Start configuration
% Config(1:10,2) = [0 40 42 -8 pi/2 pi/5 -pi/4-pi/4 0 0 0]'; %Goal configuration

% Config(1:10,1) = [0 65 23 -2 pi pi/9 pi/8-pi/4 pi/3 0 0]';     %Start configuration
% Config(1:10,2) = [0 62 41 -7 (pi-pi/4) pi/9 -pi/8-pi/4 pi/4 0 0]'; %Goal configuration

% Config(1:10,1) = [0 65 45 -2 pi pi/9 pi/8 pi/3 pi/3 0]';     %Start configuration
% Config(1:10,2) = [0 61 39 -7 (pi-pi/4) pi/9 -pi/8 pi/4 pi/2 0]'; %Goal configuration
% Config(1:10,1) = [0 63 25 -8 pi pi/5 -pi/4-pi/4 0 0 0]';  
% Config(1:10,2) = [0 63 25 -8 pi pi/5 -pi/4-pi/4 0 0 0]';%Start configuration
Config(1:10,1) = [0 42 15 -8 -pi/2 pi/5 -pi/4-pi/4 0 0 0]';
Config(1:10,2) = [0 52 10 -8 -pi/2 pi/5 -pi/4-pi/4 0 0 0]'; %Goal configuration

for i=1:2
    
   [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] ...
       = makeRobot(Config(2:4,i), Config(5:10,i));

   [inter] = collisionCheckABB(10, obsN, Manip, lRot, lTrans, Obstacles, oRot, oTrans )  ;
   if inter
       i
          makeAndDrawRobot(Config(2:4,i), Config(5:10,i),4,[1 1 0])
       error('inter')
   else
          makeAndDrawRobot(Config(2:4,i), Config(5:10,i),4,[1 0 0])
   end
end

% Run the binary collision check
[inter] = binCollisionCheckABB_New(Config,maxStep,maxAngle, linksN, obsN, Obstacles, oRot, oTrans)

initialPos = Config(2:4,1);
thetaStart = Config(5:10,1);
finalPos   = Config(2:4,2);
thetaFinal = Config(5:10,2);