% Make samples

function [Samples comp] = makeGaussianSamples_Nearest_k(K, LinLimits, JALimits, stepLength,w,step, Obstacles, oRot, oTrans)

stopCon = 50;

[obsN notInUse2] = size(Obstacles);

%%%%%%%% Starting the Probabilistic RoadMap method%%%%%%%              
%Config(1:8,1:4,4,1000) = zeros;
comp(1) = struct('Node',[1], 'NB',[0]);
emptyComp(1) = 2;

con = 1;
for pos =1:20000
    
    % Make a new random robot configuration
    [ManipD, ManD, fTD, lTD, lRotD, lTransD, DHD, linValuesD, thetaD] =...
        makeRandomRobotConfig();
    [linksN notInUse1] = size(ManipD);

    % Checking for collision  between links and obstacles
    collisionDummy = collisionCheckABB(linksN, obsN, ManipD, lRotD, lTransD, Obstacles, oRot, oTrans);
    
    % If the robot manipulator collide, make a new neighbour sample
    if collisionDummy
        conf(2:4,1) = linValuesD;
        conf(5:10,1)= thetaD;
        newConfig = moveRandDir(step,w,conf, LinLimits, JALimits);
        
        linValues = newConfig(2:4);
        theta = newConfig(5:10);

        [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, theta );
        collision = collisionCheckABB(linksN, obsN, Manip, lRot, lTrans, Obstacles, oRot, oTrans);
        % if no collision detected in current configuration, store
        % the configuration
        if collision == false
%             drawRobot(1,[1 0 0], linksN, Manip, lRot, lTrans)
%             drawGantryCrane(1, fT, linValues(1))
            %                     theta = [Th1 Th2 Th3 Th4]';
            Samples(1,con) = 0;
            Samples(2:4,con) = linValues;
            Samples(5:10,con)= theta;
            Samples(11,con) = 0;

            %         % plot the configuration
            %         plot3( [fT(1,4,1) fT(1,4,2) fT(1,4,3) fT(1,4,4)],[fT(2,4,1) fT(2,4,2) fT(2,4,3) fT(2,4,4) ],[fT(3,4,1) fT(3,4,2) fT(3,4,3) fT(3,4,4)] )

            if con == 1
                Samples(11,con)=1; %Sample 1 belongs to component 1
            else
                clear TempMat;
                for teller = 1:con-1 %Computing distance to all nodes in  one component
                    TempMat(teller,:) = [configDist([ 0; linValues; theta], Samples(1:10,teller), w ),teller ];
                end

                % Sort the matrix with increasing distance
                clear sortMat;
                sortMat = sortrows(TempMat);
                % Try make a connection between current node
                % and closest node
                [rows col] = size(sortMat);
                if rows>K
                    rows = K;
                end

                Config(1:10,1) = [0; linValues; theta ];
                for ind=1:rows
                    c = Samples(11,sortMat(ind,2));
                    %                                     Config(1:10,1) = [0; linValues; theta ];
                    Config(1:10,2) = Samples(1:10, sortMat(ind,2));
                    interaction = binCollisionCheckABB( Config,1, stepLength,linksN, obsN, Obstacles, oRot, oTrans);
                    if ~interaction % If no interaction, add the node to the component
                        [ connectSuccess Samples comp emptyComp] = connectNodeABB_K(con, c, ind, Samples, comp, sortMat, emptyComp);
                        if connectSuccess % Node added to component break for loop
                            break;
                        end
                    end
                end % If no connection found , try next sample.

                % if component connection failed, make a new component
                [Samples comp emptyComp] = connectToEmptyComponentABB(con,Samples, comp, emptyComp);
            end
            con = con + 1;
            
%             if con==stopCon % Do some testing
%                 %%%%%%%% TESTING, STOP SAMPLE TIMER%%%%%%
%                 %% Test the probabilistic road map
%                 
%                 [testConfigCovered, TestQueryConnection, nTestNodes ] = PRM_4(Components, Samples);
%                 interval = stopCon/50;
%                 % Storing the covering
%                 Coverage(:,interval) = testConfigCovered;
%                 % Storing the connection
%                 TestResultConnection(:,:,interval) = TestQueryConnection;
%                 sumColums = sum(TestQueryCovered);
%                 sumQueriesCovered(interval) = sum(sumColums);
%                 
%                 stopCon = stopCon + 50;
%                 if stopCon == 300
%                     disp('Reached 300 samples')
%                     return
%                 end
%             end
            
        end
    end %end the bad configuration
end %end the pos loop

disp('Done with Gaussian sampling')
